(defun loadif  (plik / ff ext)
  (cond ((or #Brics #GSTAR #GSTAR8 #ARES)
         (setq ext ".lsp"))
        (#ZWCAD2017
         (setq ext ".zel"))
        (T
          (if #LTVer
            (if #Toolkit
              (setq ext ".das")
              (setq ext ".des"))
            (setq ext ".fas"))))        
  (setq plik (strcat plik ext))
  (if (setq ff (findfile plik))
    (progn (load ff) T)
    (progn (arx_message_box
             #tile_msg2000
             (strcat "Nie odnaleziono skadnika programu [" plik "].\nPolecenie nie moe by uruchomione!")
             6
             2
             0
             1)
           nil)))

;;;(defun loadif (plik / ff ext)
;;;  (cond (#Brics
;;;         (setq ext ".lsp"))
;;;        ((or #GSTAR #GSTAR8)
;;;         (if #x64
;;;           (setq ext ".fas")
;;;           (setq ext ".lsp")))
;;;        (T (setq ext ".fas")))
;;;  (setq plik (strcat plik ext))
;;;  (if (setq ff (findfile plik))
;;;    (progn (load ff) T)
;;;    (progn (arx_message_box
;;;             #tile_msg2000
;;;             (strcat "Nie odnaleziono skadnika programu [" plik "].\nPolecenie nie moe by uruchomione!")
;;;             6
;;;             2
;;;             0
;;;             1)
;;;           nil)))

(defun dwg_MakeGroup ()
  T)

(defun progress_init (tile size) (arx_saczek_init tile size) (setq #is_progress T))

(defun progress_run (i) (arx_saczek_run i))

(defun progress_done () (arx_saczek_done) (setq #is_progress nil))

(defun InsertPoint  (%p %nr typ %code dodaj / bNa bk)
  (setlay (strcat "PP" typ "P"))
  (setq bk nil
        bNa (strcat "PIK_" typ))
  (if (and (definiuj_blok bNa T)
           (setq bk (_createBlock bNa %p 0 (list (vl-string-trim " " %nr) %code))))
    (progn (write_attrib->Point bk)
           (if dodaj
             (setq #glob_lstPoints (append #glob_lstPoints (list (vlax-ename->vla-object bk)))))))
  bk)

(defun msg-file-size  (plik / licznik)
  (setq licznik 0)
  (if (setq #fle (open plik "r"))
    (progn (while (read-line #fle) (setq licznik (1+ licznik))) (msg_close_fle)))
  licznik)

(defun del_comment  (linia / p)
  (if (> (setq p (_pos "//" linia)) 0)
    (cond ((= p 1) (setq linia ""))
          (T (setq linia (substr linia 1 (1- p))))))
  linia)

(defun app_comment  (linia &commet / p)
  (if (> (setq p (_pos "//" linia)) 0)
    (cond ((= p 1) (set &commet linia) (setq linia ""))
          (T (set &commet (substr linia (+ p 2) (strlen linia))) (setq linia (substr linia 1 (1- p)))))
    (set &commet ""))
  linia)

(defun pos_skala  (&_skala / skala licznik)
  (setq skala (dwg_skala))
  (if (= skala 0)
    (progn (setq skala 1000) (PUTdwg_skala skala)))
  (cond ((< skala 750) (setq licznik 0))
        ((and (>= skala 750) (< skala 1500)) (setq licznik 1))
        ((and (>= skala 1500) (< skala 3000)) (setq licznik 2))
        (T (setq licznik 3)))
  (set &_skala skala)
  licznik)

(defun skala->pozycjaListy (lista / skala) (nth (pos_skala 'skala) lista))

(defun skalaDowolna->pozycjaListy (lista skala) (nth (vl-position skala #lst_skal) lista))

(defun _swap (&v1 &v2 / v) (setq v (eval &v1)) (set &v1 (eval &v2)) (set &v2 v))

(defun msg_podziel  (s / result)
  (if (setq result (_podziel s))
    (if (null (listp result))
      (setq result (list result))))
  result)

(defun readAttdefAsEname  (bName AttName / bl e result)
  (setq result nil)
  (if (setq bl (tblsearch #cBLOCK bName))
    (progn (setq bl (casc -2 bl))
           (while bl
             (setq e (entget bl))
             (if (= (casc 0 e) #cATTDEF)
               (if (= (strcase (casc 2 e)) (strcase AttName))
                 (setq result bl)))
             (setq bl (entnext bl)))))
  result) 

(defun read_attdef->block  (block_name &ok_res / result bl ok)
  (setq result '())
  (if (setq bl (tblsearch #cBLOCK block_name))
    (progn (set &ok_res T)
           (setq bl (casc -2 bl))
           (while bl
             (if (equal (casc 0 (entget bl)) #cATTDEF)
               (setq result (append result (list (casc 3 (entget bl))))))
             (setq bl (entnext bl))))
    (set &ok_res nil))
  result)

(defun read_attdefName->block  (block_name / result bl ok)
  (setq result '())
  (if (setq bl (tblsearch #cBLOCK block_name))
    (progn (setq bl (casc -2 bl))
           (while bl
             (if (and (equal (casc 0 (entget bl)) #cATTDEF) (/= (casc 70 (entget bl)) 2))
               (setq result (append result (list (list (casc 2 (entget bl)) (casc 3 (entget bl)))))))
             (setq bl (entnext bl)))))
  result)

(defun read_all_attrib->block  (ename / _retlist)
  (setq _retlist '())
  (while (and (setq ename (entnext ename)) (equal (casc 0 (entget ename)) #cATTRIB))
    (setq _retlist (append _retlist (list (casc 1 (entget ename))))))
  _retlist)

(defun read_attrib->block  (ename atr / ok e _ret)
  (setq _ret nil
        ok   nil)
  (while (and (null ok)
              (entnext ename)
              (equal (casc 0 (setq e (entget (setq ename (entnext ename))))) #cATTRIB))
    (if (setq ok (equal (strcase (casc 2 e)) (strcase atr)))
      (setq _ret (casc 1 e))))
  (EmptyIfNull _ret))

(defun check_is_new  (/ result)
  (if (setq result (/= (dwg_skala) 0))
    (mapcar '(lambda (lay) (setq result (and result (tblsearch "LAYER" lay)))) #lista_warstw))
  (not result))

(defun _mnil (var) (mapcar '(lambda (&) (set & nil)) var) (gc) (princ))

(defun casc (a b) (cdr (assoc a b)))

(defun w_nth  (ename elist)
  (if (member ename elist)
    (- (length elist) (length (member ename elist)))
    nil))

(defun del_last_lst  (lst)
  (setq lst (reverse lst)
        lst (cdr lst)
        lst (reverse lst))
  lst)

(defun main_item  (item / _ret)
  (cond ((or (equal (casc 0 (entget item)) #cVERTEX)
             (equal (casc 0 (entget item)) #cATTRIB)
             (equal (casc 0 (entget item)) #cPOLYLINE))
         (while (/= (casc 0 (entget (setq item (entnext item)))) #cSEQEND))
         (setq _ret (casc -2 (entget item))))
        (T (setq _ret item)))
  _ret)

(defun del_item_lst  (item elist)
  (if (member item elist)
    (vl-remove item elist)
    elist))

(defun del_pos_lst  (posItem elist / l _ret len)
  (setq l    0
        _ret '())
  (foreach &  elist
    (if (/= l posItem)
      (setq _ret (append _ret (list &))))
    (setq l (1+ l)))
  _ret)

(defun change_item_lst  (it item elist / l nlist nitem)
  (setq l 0)
  (if (and (>= it 0) (< it (length elist)))
    (repeat (length elist)
      (if (= it l)
        (setq nitem item)
        (setq nitem (car elist)))
      (setq l     (1+ l)
            nlist (append nlist (list nitem))
            elist (cdr elist)))
    (setq nlist elist))
  nlist)

(defun wydaj->ext  (/ res)  
  (setq res (cond ((or (null #wsp) (<= #wsp 0.5)) 0.5)
                  ((and (> #wsp 0.5) (<= #wsp 1.0)) 1.0)
                  ((and (> #wsp 1.0) (<= #wsp 2.0)) 2.0)
                  (T 5.0)))
  (itoa (fix res)))


(defun wydaj_blok->ext  ()
  (strcat "-" (wydaj->ext)))

(defun redefBlock  (name / bName tmpP newN ret expert attreq copyF)
  (setq bName  (vl-filename-base (StrLeftValue name))
        tmpP   (vl-filename-mktemp "msg.dwg")
        newN   (strcat (vl-filename-directory tmpP) "\\" bName ".dwg")
        ret    nil
        expert (getvar "EXPERT")
        attreq (getvar "ATTREQ"))
  (if (findfile newN)
    (vl-file-delete newN))
  (setq copyF (StrRightValue name))
  (if (null (vl-filename-extension copyF))
    (setq copyF (strcat copyF ".dwg")))
  (if (and (vl-file-copy copyF tmpP) (vl-file-rename tmpP newN))
    (progn (setvar "EXPERT" 5)
           (setvar "ATTREQ" 0)      
           (setq ret (vla-InsertBlock #modelS (vlax-3d-point (list 0 0 0)) newN 1 1 1 0))
           (if ret
             (vla-delete ret))
           (setvar "EXPERT" expert)
           (setvar "ATTREQ" attreq)
           (vl-file-delete newN))))

(defun BlokSelLayProp  (findBlok / l block)
  (if (tblsearch #cBLOCK findBlok)
    (progn (setq block (vla-item (vla-get-blocks #acadDoc) findBlok)
                 l     0)
           (while (< l (vla-get-Count block))
             (arxLayerSetProp (vla-get-Layer (vla-item block l)))
             (setq l (1+ l)))))
  (princ))

(defun definiuj_blok  (name prError / oki)
  (setq oki (XTDefiniujBlok name))
  (if (and (null oki) prError)
    (princ (strcat "\nNie zdefiniowany blok " (strcase name) "!")))
  oki)

(defun rs_error () (set_tile "error" ""))

(defun check_nr  (nr)
  (if (= (strlen (get_tile nr)) 0)
    (progn (msg_beep_reaction)
           (set_tile "error" "Pole NUMER musi by wypenione.")
           (mode_tile nr 2)
           nil)
    (progn (rs_error) (get_tile nr))))

(defun check_real  (real_n prom nie_moze_byc_pusty / realN)
  (setq realN (vl-string-subst "." "," (get_tile real_n)))
  (set_tile real_n realN)
  (if (or (and (not nie_moze_byc_pusty) (= (strlen realN) 0)) (distof realN 2))
    (progn (rs_error) realN)
    (progn (set_tile "error" (strcat "Niepoprawna warto w polu [" prom "]."))
           (mode_tile real_n 2)
           nil)))

(defun check_real1  (r_n prom)
  (if (or (= (strlen r_n) 0) (distof r_n 2))
    (progn (rs_error) r_n)
    (progn (set_tile "error" (strcat "Bdne znaki w polu [" prom "].")) nil)))

(defun check_r  (real_n prom var)
  (cond ((and (distof (get_tile real_n) 2) (>= (atof (get_tile real_n)) var)) (rs_error) real_n)
        (T (set_tile "error" (strcat "Bdna warto w [" prom "].")) (mode_tile real_n 2) nil)))

(defun dialog->yes_no  (message / res)
  (setq res (arx_message_box #tile_msg2000 message 5 5 0 1))
  (cond (#GSTAR (= res 6))
        ((<= #AcadVer 16) (= res 6))
        (T (= res 7))))

(defun msg_open_fle  (_fname _tr)
  (cond ((setq #fle (open _fname _tr)) #fle)
        (T nil)))

(defun msg_close_fle  ()
  (if #fle
    (progn (close #fle) (setq #fle nil))))

(defun _wydajZakres  (&zakres / wz_result _zakres poz p k)
  (set &zakres (EmptyIfNull (eval &zakres)))
  (if (setq wz_result (> (strlen (eval &zakres)) 0))
    (progn (setq _zakres '())
           (foreach &  (_podziel_znak (eval &zakres) ",")
             (setq poz (_pos "-" &))
             (cond ((> poz 0)
                    (setq p (string->Def-If-Empty (substr & 1 (1- poz)) "0")
                          k (string->Def-If-Empty (substr & (1+ poz)) (_strings "9" 20)))
                    (if (and (distof p) (distof k))
                      (if (> (distof p) (distof k))
                        (_swap 'p 'k))
                      (setq p nil
                            k nil)))
                   (T
                    (setq poz (string->Def-If-Empty & "0"))
                    (if (distof poz)
                      (setq p &
                            k &))))
             (if (and p k)
               (setq _zakres (append _zakres (list (strcat p "-" k))))))
           (set &zakres _zakres))
    (set &zakres nil))
  wz_result)

(defun _isMarket  (punkt zakres code mask_code / result pp p k)
  (if (and zakres (listp zakres))
    (progn (setq result nil)
           (foreach &  zakres
             (if (> (setq pp (_pos "-" &)) 0)
               (progn (setq p (substr & 1 (1- pp))
                            k (substr & (1+ pp)))
                      (if (and (distof p)
                               (distof k)
                               (distof punkt)
                               (>= (distof punkt) (distof p))
                               (<= (distof punkt) (distof k)))
                        (setq result T))))))
    (setq result T))
  (and result (wcmatch code mask_code)))

(defun list_box->selectedList (list_box) (read (strcat "(" list_box ")")))

(defun dialog_lista_punktow  (&allset &selset / _id list_all list_sel what ss selected_all selected_sel prepare_list sort_list display_selected do_list do_all display_list do_add)
  (defun do_add  (key / l)
    (cond ((= key "add")
           (foreach & selected_all (setq list_sel (append list_sel (list (nth & list_all)))))
           (setq l 0)
           (foreach &  selected_all
             (setq list_all (del_pos_lst (- & l) list_all)
                   l        (1+ l)))
           (setq list_sel     (sort_list list_sel)
                 selected_all '()))
          (T
           (foreach & selected_sel (setq list_all (append list_all (list (nth & list_sel)))))
           (setq l 0)
           (foreach &  selected_sel
             (setq list_sel (del_pos_lst (- & l) list_sel)
                   l        (1+ l)))
           (setq list_all     (sort_list list_all)
                 selected_sel '())))
    (display_list)
    (display_selected))
  (defun display_list  ()
    (start_list "list_full")
    (foreach & list_all (add_list (car &)))
    (end_list)
    (start_list "list_add")
    (foreach & list_sel (add_list (car &)))
    (end_list))
  (defun do_all  (key)
    (cond ((= key "all_add")
           (setq list_sel     (sort_list (append list_sel list_all))
                 list_all     '()
                 selected_all '()))
          (T
           (setq list_all     (sort_list (append list_all list_sel))
                 list_sel     '()
                 selected_sel '())))
    (display_list)
    (display_selected))
  (defun do_list  (key value)
    (cond ((= key "list_full") (setq selected_all (list_box->selectedList value)))
          (T (setq selected_sel (list_box->selectedList value))))
    (display_selected))
  (defun sort_list  (lst)
    (if (> (length lst) 0)
      (setq lst (vl-sort lst '(lambda (v1 v2) (< (car v1) (car v2)))))
      (setq lst '()))
    lst)
  (defun prepare_list  (ss / result len l p nr)
    (if ss
      (progn (setq result '()
                   len    (sslength ss)
                   l      0)
             (while (< l len)
               (setq p      (ssname ss l)
                     l      (1+ l)
                     nr     (casc 1 (entget (entnext p)))
                     result (append result (list (list (_add nr 15 T) p))))))
      (setq result '()))
    (sort_list result))
  (defun display_selected  (/ _c)
    (setq _c " z ")
    (set_tile "display_all" (strcat (itoa (length selected_all)) _c (itoa (length list_all))))
    (set_tile "display_sel" (strcat (itoa (length selected_sel)) _c (itoa (length list_sel)))))
  (if (and (or (eval &allset) (eval &selset))
           (or (> (sslength (eval &allset)) 0) (> (sslength (eval &selset)) 0))
           (>= (setq _id (load_dialog #msg_dcl_file)) 0)
           (new_dialog "lista_punktow" _id))
    (progn (setq list_all     (prepare_list (eval &selset))
                 list_sel     (prepare_list (eval &allset))
                 selected_all '()
                 selected_sel '())
           (display_list)
           (display_selected)
           (action_tile "list_full" "(do_list $key $value)")
           (action_tile "list_add" "(do_list $key $value)")
           (action_tile "all_add" "(do_all $key)")
           (action_tile "all_del" "(do_all $key)")
           (action_tile "add" "(do_add $key)")
           (action_tile "del" "(do_add $key)")
           (action_tile "accept" "(done_dialog 1)")
           (action_tile "cancel" "(done_dialog 0)")
           (setq what (start_dialog))
           (unload_dialog _id)
           (cond ((= what 1)
                  (setq ss (ssadd))
                  (foreach & list_sel (ssadd (cadr &) ss))
                  (set &allSet ss)
                  (setq ss (ssadd))
                  (foreach & list_all (ssadd (cadr &) ss))
                  (set &selSet ss))))))

(defun dlgDispGodlo  (__strefa __skala __point &godlo &ne &ld &pg / wynik xS yS)
  (setq #badaj nil)
  (if (setq wynik (cond ((or (equal __strefa 0) (null (member (fix __skala) #lst_skal))) nil)
                        ((< __strefa 7) (_godloArkusza __point __strefa __skala nil nil))
                        ((eq __strefa 11) (_godloWWA __point __skala))
                        ((eq __strefa 12) (_godloKR __point __skala))
                        (T (_godlo92 __point __skala (- __strefa 2) nil))))
    (progn (set &ne (cadr wynik))
           (set &ld (nth 2 wynik))
           (set &pg (nth 3 wynik))
           (set &godlo (car wynik)))
    (progn (set &ne "") (set &ld nil) (set &pg nil) (set &godlo "")))
  (set_tile "skala" (idx_skala __skala))
  (set_tile "strefa" (itoa __strefa))
  (set_tile "godlo" (eval &godlo))
  (set_tile "ne" (eval &ne))
  (cond ((eval &ld)
         (Uklad->Wspolrz (eval &ld) 'xS 'yS)
         (set_tile "xld" (rtos xS 2 #prec))
         (set_tile "yld" (rtos yS 2 #prec)))
        (T (set_tile "xld" "") (set_tile "yld" "")))
  (cond ((eval &pg)
         (Uklad->Wspolrz (eval &pg) 'xS 'yS)
         (set_tile "xpg" (rtos xS 2 #prec))
         (set_tile "ypg" (rtos yS 2 #prec)))
        (T (set_tile "xpg" "") (set_tile "ypg" "")))
  (mode_tile "ne"
             (if (< __strefa 6)
               0
               1))
  (mode_tile "zoom"
             (if (and (eval &pg) (eval &ld))
               0
               1))
  (mode_tile "boxed_kresl"
             (if (and (eval &pg) (eval &ld))
               0
               1))
  (mode_tile "siatka"
             (if (and (= __skala (dwg_skala)) (= __strefa (dwg_uklad)))
               0
               1))
  (if (and (eval &ld) (eval &pg))
    (mode_tile "accept" 2)))


(defun _dialogSekcjaWydaj  (/ s_id s_wnext s_strefa s_skala s_godlo s_ne s_ld s_pg s_pk s_result s_point_base o_zoom s_end s_do_godlo)
  (defun s_do_godlo  (key / g n p dyx ilosc_znakow)
    (if (> (strlen (get_tile key)) 0)
      (progn (setq g (msg-string-remove (get_tile "godlo") ".")
                   n (get_tile "ne"))
             (cond ((equal key "godlo")
                    (setq n ""
                          s_ne n))
                   (T
                    (setq n            (get_tile "ne")
                          ilosc_znakow (_pos "." n))
                    (cond ((= ilosc_znakow 0) (setq is_exit T))
                          (T
                           (setq n            (msg-string-remove n ".")
                                 is_exit      nil
                                 ilosc_znakow (1- ilosc_znakow))))
                    (setq g ""
                          s_godlo g)))
             (cond (is_exit (princ))
                   ((and (/= s_strefa 11) (/= s_strefa 12) (not (check_real1 g "godle"))))
                   ((and (/= s_strefa 11) (not (check_real1 n "NE"))))
                   (T
                    (cond ((eq s_strefa 12)
                           (if (setq p (_narozaKR (get_tile "godlo") 's_skala))
                             (setq p (car p))))
                          ((eq s_strefa 11)
                           (if (setq p (_narozaWWA (get_tile "godlo") 's_skala))
                             (setq p (car p))))
                          ((> s_strefa 6)
                           (setq s_godlo (get_tile "godlo")
                                 g       (_podziel_znak s_godlo ".")
                                 p       (_naroze92 g 's_skala 'dyx nil)))
                          (T
                           (setq p (wydajWspArkusza g n s_strefa ilosc_znakow))
                           (if (car p)
                             (setq s_skala  (nth 2 p)
                                   s_strefa (nth 3 p)
                                   p        (car p)))))
                    (if p
                      (progn (setq s_point_base (list (+ (car p) 1) (+ (cadr p) 1)))
                             (dlgDispGodlo s_strefa s_skala s_point_base 's_godlo 's_ne 's_ld 's_pg))))))))
  (defun s_end  (var / g n)
    (cond ((= var 0) (setq s_result nil))
          (T
           (if (and s_ld s_pg)
             (setq s_result (list (get_tile "godlo") (get_tile "ne") s_ld s_pg))
             (setq s_result nil))))
    (setq #scr-sWy (done_dialog var)))
  (if (>= (setq s_id (load_dialog #msg_dcl_file)) 0)
    (progn (setq s_point_base (getvar "VIEWCTR")
                 s_skala      (dwg_skala)
                 s_strefa     (dwg_uklad)
                 o_zoom       (get_currZoom)
                 s_wnext      2)
           (while (and (> s_wnext 1) (new_dialog "sekcjaWydaj" s_id "" #scr-sWy))
             (popupStrefa)
             (popup_skala)
             (dlgDispGodlo s_strefa s_skala s_point_base 's_godlo 's_ne 's_ld 's_pg)
             (action_tile
               "skala"
               "(progn(setq s_skala (nth (atoi $value) #lst_skal))
	   (dlgDispGodlo s_strefa s_skala s_point_base 's_godlo 's_ne 's_ld 's_pg))")
             (action_tile
               "strefa"
               "(progn(setq s_strefa (atoi $value))
	   (dlgDispGodlo s_strefa s_skala s_point_base 's_godlo 's_ne 's_ld 's_pg))")
             (action_tile "godlo" "(s_do_godlo $key)")
             (action_tile "ne" "(s_do_godlo $key)")
             (action_tile "wskaz" "(s_end 2)")
             (action_tile "zoom" "(s_end 3)")
             (action_tile "accept" "(s_end 1)")
             (action_tile "cancel" "(s_end 0)")
             (setq s_wnext (start_dialog))
             (cond ((equal s_wnext 2)
                    (if (setq s_pk (getpoint #WskPunNaArk))
                      (setq s_point_base s_pk)))
                   ((equal s_wnext 3)
                    (if (and s_ld s_pg)
                      (if !command-s
                        (command-s "_.ZOOM" "_W" s_ld s_pg)
                        (vl-cmdf "_.ZOOM" "_W" s_ld s_pg))))))
           (unload_dialog s_id)
           (arxZoomWindow (car o_zoom) (cadr o_zoom))))
  s_result)

(defun dialog_wybierzPunkty_okno  (wnext &&godlo &&corner &&tile_punkty &&cen &&rad / w1 w2 wp dx dy siz _cor)
  (if (and (> wnext 1) (< wnext 8))
    (set &&godlo ""))
  (cond ((= wnext 2)
         (if (setq w1 (_dialogSekcjaWydaj))
           (progn (set &&godlo (car w1)) (set &&corner (list (caddr w1) (cadddr w1))))
           (set &&tile_punkty "wszystkie")))
        ((= wnext 3) (set &&corner (get_currZoom)))
        ((= wnext 4)
         (cond ((setq dx (getpoint "\nrodek okrgu: "))
                (setLay "0")
                (prompt "\nPromie: ")
                (if !command-s
                  (command-s "_.CIRCLE" dx PAUSE)
                  (command "_.CIRCLE" dx PAUSE))
                (setq dy (casc 40 (entget (setq siz (entlast)))))
                (entdel siz)
                (set &&corner
                     (list (list (- (car dx) dy) (- (cadr dx) dy)) (list (+ (car dx) dy) (+ (cadr dx) dy))))
                (set &&cen dx)
                (set &&rad dy))
               (T (set &&tile_punkty "wszystkie"))))
        ((= wnext 5)
         (if (setq _cor (msg_getXY (eval &&corner)))
           (set &&corner _cor)
           (set &&tile_punkty "wszystkie")))
        ((= wnext 6)
         (initget "Obiekt")
         (if (setq w1 (getpoint "\nObiekt/[Pierwszy wierzchoek wieloboku]: "))
           (progn
             (cond ((eq w1 "Obiekt")
                    (if (and (setq siz (entsel #WskZamPoly)) (eq (casc 0 (entget (setq siz (car siz)))) #cPOLYLINE))
                      (progn (setq siz (polyline->wierzcholki siz)))))
                   (T
                    (setq siz (list w1))
                    (while (setq w2 (getpoint w1 "\nNastpny wierzchoek: "))
                      (grdraw w1 w2 -1 1)
                      (setq siz (append siz (list w2))
                            wp  w1
                            w1  w2))
                    (redraw)))))
         (if (or (null siz) (< (length siz) 3))
           (set &&tile_punkty "wszystkie")
           (set &&corner siz)))))

(defun _selectPointsFromDialog  (wnext &ss_result &sstmp zakres def_cod &tile_punkty &godlo filter &corner &cen &rad &lastAction / ctr siz dy dx w1 w2 _cor ex ss is_zakres l len ss_res cod typ)
  (cond ((and (= wnext 8) (= (eval &lastAction) 8)) (dialog_lista_punktow &sstmp &ss_result))
        (T
         (dialog_wybierzPunkty_okno wnext &godlo &corner &tile_punkty &cen &rad)
         (cond ((or (and (= wnext 1) (= (eval &lastAction) 0)) (and (> wnext 1) (< wnext 9)))
                (if (setq ss (selectPointsFromCorner (eval &tile_punkty) (eval &corner) (eval &cen) (eval &rad) filter))
                  (progn (setq is_zakres (_wydajZakres 'zakres)
                               l         0
                               ss_res    (ssadd)
                               len       (sslength ss))
                         (while (< l len)
                           (setq p   (ssname ss l)
                                 typ (substr (casc 2 (entget p)) 5 2))
                           (if (arxHasAttributes p)
                             (setq
                                 ex  (entnext p)
                                 nr  (if (and ex (entget ex) (eq (casc 0 (entget ex)) #cATTRIB))
                                       (casc 1 (entget ex))
                                       "*")
                                 ex  (entnext ex)
                                 cod (if (and ex (entget ex) (eq (casc 0 (entget ex)) #cATTRIB))
                                       (casc 1 (entget ex))
                                       ""))
                             (setq nr "" cod ""))
                             (setq l   (1+ l))
                           (if (_isMarket nr zakres cod def_cod)
                             (ssadd p ss_res)))
                         (set &sstmp ss_res)
                         (cond ((= wnext 8) (set &ss_result (ssadd)) (dialog_lista_punktow &sstmp &ss_result))
                               (T (set &ss_result (eval &sstmp))))))))))
  (set &lastAction wnext))

(defun selectPointsFromCorner  (punkty corner _cen _rad filter / ss ssp l)
  (cond ((= punkty "poligon") (setq ss (ssget "_CP" corner filter)))
        ((= punkty "okrag")
         (setq l 0)
         (if (setq ss (ssget "_C" (car corner) (cadr corner) filter))
           (while (< l (sslength ss))
             (if (> (distRed (casc 10 (entget (ssname ss l))) _cen) _rad)
               (progn (ssdel (ssname ss l) ss) (setq l (1- l))))
             (setq l (1+ l)))))
        ((= punkty "wszystkie") (setq ss (ssget "_X" filter)))
        (T
         (setq ssp (ssget "_C" (car corner) (cadr corner) filter)
               ss  (ssadd)
               l   0)
         (if ssp
           (while (< l (sslength ssp))
             (if (ok_okno (casc 10 (entget (ssname ssp l))) (car corner) (cadr corner))
               (ssadd (ssname ssp l) ss))
             (setq l (1+ l))))
         (_mnil '(ssp))))
  (if (and ss (> (sslength ss) 0))
    ss
    nil))

(defun _isSelected  (nr is_zakres zak_p zak_k code mask_code)
  (and (or (null is_zakres)
           (and (or (> (strlen nr) (strlen zak_p)) (and (= (strlen nr) (strlen zak_p)) (>= nr zak_p)))
                (or (< (strlen nr) (strlen zak_k)) (and (= (strlen nr) (strlen zak_k)) (<= nr zak_k)))))
       (wcmatch code mask_code)))

(defun raport_definiuj  (&plik ext &toggle_renum / _id l result plik toggle_renum popup_list _end st_popup do_toggle do_file check_column)
  (defun check_column  (/ result lst l)
    (setq l 0
          lst '()
          result T)
    (repeat (length (eval &toggle_renum))
      (if (= (get_tile (strcat "t" (itoa l))) "1")
        (setq lst (append lst (list (atoi (get_tile (strcat "p" (itoa l))))))))
      (setq l (1+ l)))
    (repeat (1- (length lst))
      (if (member (car lst) (cdr lst))
        (setq result nil))
      (setq lst (cdr lst)))
    (if (null result)
      (set_tile "error" "Bdnie zestawione kolumny dla danych!")
      (rs_error))
    result)
  (defun _end  (var / l len)
    (if (> var 0)
      (cond ((not (check_column)))
            (T
             (setq l   0
                   len (length (eval &toggle_renum)))
             (set &toggle_renum '())
             (repeat len
               (set &toggle_renum
                    (append (eval &toggle_renum)
                            (list (list l (atoi (get_tile (strcat "t" (itoa l)))) (atoi (get_tile (strcat "p" (itoa l))))))))
               (setq l (1+ l)))
             (set &plik (get_tile "file"))
             (done_dialog var)))
      (done_dialog var)))
  (defun st_popup (k v) (mode_tile (strcat "p" (itoa k)) (abs (1- v))))
  (defun do_toggle  (key value / nkey skey)
    (setq nkey (atoi (substr key 2))
          skey (atoi value))
    (st_popup nkey skey))
  (defun do_file  (/ p)
    (if (setq p (_getfiled plik))
      (setq plik p)))
  (setq result       nil
        plik         (eval &plik)
        toggle_renum (eval &toggle_renum))
  (if (null plik)
    (setq plik (strcat (_getFullDwgName) ext)))
  (if (and (>= (setq _id (load_dialog #msg_dcl_file)) 0) (new_dialog "renum_synchr" _id))
    (progn                          
      (setq l 1)
      (repeat (length toggle_renum)
        (setq popup_list (append popup_list (list (itoa l)))
              l          (1+ l)))
      (foreach &  toggle_renum
        (start_list (strcat "p" (itoa (car &))))
        (mapcar 'add_list popup_list)
        (end_list)
        (set_tile (strcat "t" (itoa (car &))) (itoa (cadr &)))
        (set_tile (strcat "p" (itoa (car &))) (itoa (caddr &)))
        (st_popup (car &) (cadr &))
        (action_tile (strcat "t" (itoa (car &))) "(do_toggle $key $value)"))
      (if (< (length toggle_renum) 5)
        (progn (setq l (length toggle_renum))
               (while (< l 5)
                 (mode_tile (strcat "t" (itoa l)) 1)
                 (mode_tile (strcat "p" (itoa l)) 1)
                 (setq l (1+ l)))))
      (set_tile "file" plik)
      (action_tile "get_file" "(do_file)")
      (action_tile "accept" "(_end 1)")
      (action_tile "cancel" "(_end 0)")
      (setq result (= (start_dialog) 1))
      (unload_dialog _id)))
  result)

(defun prec_wys  (blok)
  (cond ((= (substr blok 1 4) "OTRN") (dwg_precWSP))
        (T (dwg_precWSU))))

(defun toggle_slide  (key lst_varkey varonoff / slide tr)
  (mapcar '(lambda (var)
             (setq slide (strcat key (itoa var)))
             (if (= var varonoff)
               (setq tr 2)
               (setq tr 1))
             (start_image slide)
             (_toggle tr 0 0 (dimx_tile slide) (dimy_tile slide) nil)
             (slide_image 6 -2 (- (dimx_tile slide) 4) (- (dimy_tile slide) 4) (strcat "msg(" slide ")"))
             (end_image))
          lst_varkey))

(defun get_status_value  (number position)
  (cond ((> (logand (expt 2 position) number) 0) 1)
        (T 0)))

(defun set_status_value  (number value position)
  (cond ((= value 1) (setq number (logior number (expt 2 position))))
        (T
         (if (> (get_status_value number position) 0)
           (setq number (- number (expt 2 position))))))
  number)

(defun LayerBlock  (bName / ret bl _next)
  (defun _next  ()
    (and bl (or (= (casc 0 (entget bl)) #cATTDEF) (= (vla-get-Lock (vlax->Layer ret)) :vlax-true))))
  (setq ret "0")
  (if (setq bl (tblsearch "BLOCK" bName))
    (progn (setq bl  (casc -2 bl)
                 ret (casc 8 (entget bl)))
           (while (_next)
             (setq bl  (entnext bl))
             (if bl
               (setq ret (casc 8 (entget bl)))))))
  ret)

(defun SetLayerBlock (bName / ret) (setq ret (LayerBlock bName)) (SetLay ret) ret)

(defun CopyAttribToMtext  (attrib / result sAttrib &)
  (ename->vlaObj 'attrib)
  (if (and (vlax-property-available-p attrib 'MTextAttribute)
           (= (vla-get-MTextAttribute attrib) :vlax-true))
    (progn (setq sAttrib (vla-get-MTextAttributeContent attrib)
                 result  (vla-AddMText #ModelS (vla-get-InsertionPoint attrib) 0 sAttrib))
           (vlax-put-property             
             result
             'AttachmentPoint
             (AttToMtextDirection (vlax-get-property attrib 'Alignment)))
           (foreach &  (list 'Height 'Layer 'Linetype 'LinetypeScale 'Lineweight 'Rotation 'StyleName)
             (vlax-put-property result & (vlax-get-property attrib &)))
           (if (= (vla-get-Alignment attrib) acAlignmentLeft)
             (vla-put-InsertionPoint result (vla-get-InsertionPoint attrib))
             (vla-put-InsertionPoint result (vla-get-TextAlignmentPoint attrib))))
    (setq result nil))
  result)

(defun _createBlockWhen  (When nazwa point rotation Atts / result lay vAtt scale hTxt)
  (setq result nil)
  (if (and point (tblsearch #cBLOCK nazwa))
    (progn (setq scale #wsp
                 hTxt  nil)
           (if (wcmatch (substr nazwa 1 4) "OS??,GR??,EG??,SU??,OT??*")
             (progn (if (and (setq hTxt (arxgetWysT (strcase (substr nazwa 1 4)))) (distof hTxt))
                      (setq hTxt (* (atof hTxt) #wsp)))
                    ))
           ;;; 18.09.2022
           ;;; Dla wszystkich blokw
           (if (> (dwg_skala) 500)
                      (setq scale (* #wsp 0.75)))
           (setq lay    (LayerBlock nazwa)
                 result (vla-InsertBlock When (vlax-3d-point point) nazwa scale scale scale rotation))
           (if result
             (progn (if (and Atts (arxHasAttributes (vlax-vla-object->ename result)))
                      (progn (setq vAtt (vlax-safearray->list (vlax-variant-value (vla-getAttributes result))))
                             (mapcar '(lambda (At vAt)
                                        (if (and At vAt)
                                          (if (and (vlax-property-available-p vAt 'MTextAttribute) (vl-string-position (ascii "\n") At))
                                            (progn (setq At (car (_podziel_znak At "#")))
                                                   (vla-put-MTextAttribute vAt :vlax-true)
                                                   (vla-put-MTextAttributeContent vAt At)
                                                   (vla-put-MTextBoundaryWidth vAt 0.0)
                                                   (vla-put-MTextDrawingDirection vAt acByStyle)
                                                   (vla-put-TextString vAt At)
                                                   (if hTxt
                                                     (vla-put-Height vAt hTxt))
                                                   (vla-UpdateMTextAttribute vAt))
                                            (progn (vla-put-TextString vAt (car (_podziel_znak At "#")))
                                                   (if hTxt
                                                     (vla-put-Height vAt hTxt))))))
                                     Atts
                                     vAtt)))
                    (vla-put-Layer result lay)
                    (vla-update result)
                    (setq result (vlax-vla-object->ename result))))))
  result)


(defun _createBlock  (%nazwa %point %rotation %Atts)
  (_createBlockWhen #ModelS %nazwa %point %rotation %Atts))

(defun _createBlockScale (nazwa point rotation scale Atts / odlWsp res)
  (setq oldWsp #wsp
        #wsp scale
        res (_createBlock nazwa point rotation Att)
        #wsp oldWsp)
  res)
  
(defun _createLine  (lay w1 w2 / res)
  (setq res (arxAddLine lay nil w1 w2))
  (vla-put-Linetype (vlax-ename->vla-object res) "Bylayer")
  res)

(defun _createPolyline  (lay closed elist)
  (if (null closed)
    (setq closed 0))
  (entmake (list (cons 0 #cPOLYLINE)
                 (cons 8 lay)
                 '(66 . 1)
                 '(10 0.0 0.0 0.0)
                 (cons 70 closed)
                 '(40 . 0.0)
                 '(41 . 0.0)
                 '(41 . 0.0)
                 '(210 0.0 0.0 1.0)
                 '(71 . 0)
                 '(72 . 0)
                 '(73 . 0)
                 '(74 . 0)
                 '(75 . 0)))
  (foreach &  elist
    (entmake (list (cons 0 #cVERTEX)
                   (cons 8 lay)
                   (cons 10 &)
                   '(40 . 0.0)
                   '(41 . 0.0)
                   '(42 . 0.0)
                   '(70 . 0)
                   '(50 . 0.0)
                   '(71 . 0)
                   '(72 . 0)
                   '(73 . 0)
                   '(74 . 0))))
  (entmake (list (cons 0 #cSEQEND) (cons 8 lay)))
  (entlast))

(defun _createPolylineLuki  (layer closed wierzLuki)
  (entmake (list (cons 0 #cPOLYLINE) (cons 8 layer) '(10 0.0 0.0 0.0) (cons 70 closed)))
  (foreach &  wierzLuki
    (entmake (list (cons 0 #cVERTEX) (cons 8 layer) (cons 10 (car &)) (cons 42 (cadr &)))))
  (entmake (list (cons 0 #cSEQEND) (cons 8 layer)))
  (entlast))

(defun _createMline  (lay mline _cl elist skala / ret)
  (wczytaj_mlstyle (car mline))
  (if (and (= _cl 1) (< (length elist) 3))
    (setq _cl 0))
  (if #Brics
    (setvar "CMLJUST" (cadr mline)))
  (if (null skala)
    (setq skala (skala_multilinii (car mline))))
;;(print mline)  
  (setq ret (arxAddMline lay (car mline) skala (cadr mline) _cl elist))
  (if #Brics
     (vla-put-MLineScale (vlax-ename->vla-object ret) skala))
  ret
  )

(defun _createMlineSk  (lay mLine _cl elist / skal)
  (if (vl-string-search "%" (car mLine))
    (setq skal #lst_szSc
          mLine (list (vl-string-subst "" "%" (car mLine)) (cadr mLine)))
    (setq skal nil))
        ;;;;  mLine (list (strcat (car mLine) (wydaj_blok->ext)) (cadr mLine))))
  (_createMline lay mLine _cl elist skal))

(defun LWPolyline->wierzcholki (item) (Polyline->wierzcholki item))

(defun LWPolyline->wierzcholkiLuki (item) (Polyline->wierzcholkiLuki item))

(defun Mline->wierzcholki (item) (Polyline->wierzcholki item))

(defun Spline->wierzcholki  (item / _ret)
  (if (= (casc 0 (entget item)) #cSPLINE)
    (foreach &  (entget item)
      (if (eq (car &) 11)
        (setq _ret (append _ret (list (cdr &)))))))
  _ret)

(defun Spline->odcinek  (item pk / _sWierz _maxGo l _ret)
  (if (= (casc 0 (entget item)) #cSPLINE)
    (progn (setq _sWierz (Spline->wierzcholki item)
                 _maxGo  1000.0
                 l       1)
           (if _sWierz
             (while (< l (length _sWierz))
               (if (< (distred (srwsp (nth (- l 1) _sWierz) (nth l _sWierz)) pk) _maxGo)
                 (setq _ret   (list (nth (- l 1) _sWierz) (nth l _sWierz))
                       _maxGo (distred (srwsp (nth (- l 1) _sWierz) (nth l _sWierz)) pk)))
               (setq l (1+ l)))
             (setq _ret nil))))
  _ret)

(defun LWPolyline->Polyline  (item / _res e exdata vts)
  (setq _res item)
  (if (setq vts (LWPolyline->wierzcholkiLuki item))
    (progn (setq e      (entget item)
                 exdata (read_exdata item)
                 _res   (_createPolylineLuki (casc 8 e) (casc 70 e) vts))
           (entdel item)
           (if exdata
             (write_exdata _res exdata))))
  _res)

(defun ifLW  (plin / result wierz e exdata)
  (cond ((eq (casc 0 (entget plin)) #cLWPOLYLINE)
         (if (setq wierz (LWPolyline->wierzcholkiLuki plin))
           (progn (setq e      (entget plin)
                        exdata (read_exdata item)
                        result (_createPolylineLuki (casc 8 e) (casc 70 e) wierz))
                  (if exdata
                    (write_exdata _ret exdata))
                  (change_link plin result)
                  (entdel plin))))
        (T (setq result plin)))
  result)

(defun UsunPowieloneWierzcholki  (elist isClosed &retList %toler / element done)
  (set &retList '())
  (while (setq element (vl-some '(lambda (x y)
                                   (if (equal x y %toler)
                                     x
                                     nil))
                                elist
                                (cdr elist)))
    (setq done nil)
    (if element
      (progn (setq elist (vl-remove-if '(lambda (x) (setq done (and (null done) (eq x element)))) elist))
             (set &retList (append (eval &retList) (list element))))))
  (if (and isClosed (equal (car elist) (last elist)))
    (progn (set &retList (append (eval &retList) (list (car elist)))) (setq elist (cdr elist))))
  elist)

(defun KontrolaGeometrii  (&wlist isClosed / rList ret)
  (setq ret   nil
        rList '())
  (set &wlist (UsunPowieloneWierzcholki (eval &wlist) isClosed 'rList 0.01))
  (setq ret (> (length rList) 0))
  (if ret
    (foreach &  rList
      (prompt
        (strcat "\nPowielony wierzchoek [" (rtos (cadr &) 2 2) "," (rtos (car &) 2 2) "], Usunity."))))
  ret)

(defun ReversePline  (pline / vts vPl nList iList i &)
  (setq vts   (Polyline->wierzcholkiLuki pline)
        vPl   (vlax-ename->vla-object pline)
        nList '()
        iList '())
  (setq pozBulgeZrod (- (length vts) 1)
        i            pozBulgeZrod)
  (while (>= i 0)
    (setq pozBulgeZrod (1- pozBulgeZrod))
    (if (< pozBulgeZrod 0)
      (setq pozBulgeZrod (- (length vts) 1)))
    (setq nList (append nList (list (car (nth i vts))))
          iLIst (append iLIst (list (- (cadr (nth pozBulgeZrod vts)))))
          i     (1- i)))
  (vla-put-Coordinates vPl (listaPunktow->variantArray_3D nList))
  (setq i 0)
  (foreach & iList (vla-SetBulge vPl i &) (setq i (1+ i))))

(defun PlinePunktRzut  (pline point / vvs minD i len pt pp lnObj e42 R alfa pout pprz idx dist wo oElev)
  ; Zwraca punkt na polilinii, index odcinka, dlugosc od poczatku
  (if (vlax-property-available-p (vlax-ename->vla-object pline) 'Elevation)
    (progn  
      (setq oElev (vla-get-Elevation (vlax-ename->vla-object pline)))
      (vla-put-Elevation (vlax-ename->vla-object pline) 0.0)
  ))
  (setq point (_2D point)
        vvs   (Polyline->wierzcholkiLuki pline)
        minD  1E10
        len   (length vvs)
        pout  nil
        idx   0
        dist  0.0
        i     0)
  (while (< i (- len 1))
    (setq pt (Rzut (_2D (car (nth i vvs))) (_2D (car (nth (+ i 1) vvs))) point)
          pp (inters (_2D (car (nth i vvs))) (_2D (car (nth (+ i 1) vvs))) point pt))
    (if pp
      (if (< (distred point pp) minD)
        (progn (setq minD (distred point pp)
                     pout pp
                     idx  i))))
    (setq i (1+ i)))
  (if (null pout)
    (progn
      ; Szczegolny przypadek, 
      (setq i 0)
      (while (< i (- len 1))
        (setq pt (Rzut (_2D (car (nth i vvs))) (_2D (car (nth (+ i 1) vvs))) point)
              pp (inters (_2D (car (nth i vvs))) (_2D (car (nth (+ i 1) vvs))) point pt nil))
        (if (and pp
                 (equal (angle (car (nth i vvs)) (car (nth (+ i 1) vvs))) (angle (car (nth i vvs)) pp) 0.000001))
          (if (< (distred point pp) minD)
            (progn (setq minD (distred point pp)
                         pout pp
                         idx  i))))
        (setq i (1+ i)))))
  (if pout
    (progn (if (/= (setq e42 (cadr (nth idx vvs))) 0.0)
             (progn (setq alfa (angle (car (nth idx vvs)) (car (nth (+ idx 1) vvs)))
                          R    (/ (* (distred (car (nth idx vvs)) (car (nth (+ idx 1) vvs))) 0.5) (sin (* 2.0 (atan e42)))))
                    (if (> R 0)
                      (setq wo (polar (_2D (car (nth idx vvs))) (+ alfa (- #pi2 (* 2 (atan e42)))) R))
                      (setq wo (polar (_2D (car (nth idx vvs))) (- alfa (+ #pi2 (* 2 (atan e42)))) (abs R))))
                    (setq pout (inters (_2D (car (nth idx vvs))) (_2D (car (nth (+ idx 1) vvs))) wo point nil))))
           (if (setq lnObj (_createLine "0" point pout))
             (progn (setq lnObj (vlax-ename->vla-object lnObj)
                          pprz  (car (safearray-points (vla-IntersectWith lnObj (vlax-ename->vla-object pline) acExtendThisEntity))))
                    (if pprz
                      (setq pout pprz))
                    (vla-delete lnObj)
                    (setq i 0)
                    (while (< i idx)
                      (setq e42 (cadr (nth i vvs)))
                      (if (= e42 0.0)
                        (setq dist (+ dist (distred (car (nth i vvs)) (car (nth (1+ i) vvs)))))
                        (setq R    (abs (/ (* (distred (car (nth i vvs)) (car (nth (1+ i) vvs))) 0.5) (sin (* 2.0 (atan e42)))))
                              alfa (abs (* 2 (arcsin (/ (distred (car (nth i vvs)) (car (nth (1+ i) vvs))) (* 2.0 R)))))
                              dist (+ dist (* alfa R))))
                      (setq i (1+ i)))
                    (setq e42 (cadr (nth idx vvs)))
                    (if (= e42 0.0)
                      (setq dist (+ dist (distred (car (nth idx vvs)) pout)))
                      (setq R    (abs (/ (* (distred (car (nth idx vvs)) (car (nth (1+ i) vvs))) 0.5) (sin (* 2.0 (atan e42)))))
                            alfa (abs (* 2 (arcsin (/ (distred (car (nth idx vvs)) pout) (* 2.0 R)))))
                            dist (+ dist (* alfa R))))))))
  (if (vlax-property-available-p (vlax-ename->vla-object pline) 'Elevation)
     (vla-put-Elevation (vlax-ename->vla-object pline) oElev))
  (list pout idx dist))

(defun object->length  (object / ename wierzcholki closed e42 R alfa &l)
  (if (and (null #GSTAR) (> #AcadVer 15))
    (setq dist (vla-get-length (vlax-ename->vla-object object)))
    (progn (setq ename (casc 0 (entget object))
                 &l    1
                 dist  0.0)
           (cond ((or (equal ename #cPOLYLINE) (equal ename #cLWPOLYLINE))
                  (setq wierzcholki (cond ((equal ename #cPOLYLINE) (polyline->wierzcholkiLuki object))
                                          (T (LWPolyline->wierzcholkiLuki object)))
                        closed      (checkClosedPolyline object))
                  (if wierzcholki
                    (progn (while (< &l (length wierzcholki))
                             (setq e42 (cadr (nth (1- &l) wierzcholki)))
                             (if (= e42 0.0)
                               (setq dist (+ dist (distred (car (nth (1- &l) wierzcholki)) (car (nth &l wierzcholki)))))
                               (setq R    (abs (/ (* (distred (car (nth (1- &l) wierzcholki)) (car (nth &l wierzcholki))) 0.5)
                                                  (sin (* 2.0 (atan e42)))))
                                     alfa (abs
                                            (* 2 (arcsin (/ (distred (car (nth (1- &l) wierzcholki)) (car (nth &l wierzcholki))) (* 2.0 R)))))
                                     dist (+ dist (* alfa R))))
                             (setq &l (1+ &l)))
                           (if closed
                             (setq dist (+ dist (distred (car (car wierzcholki)) (car (last wierzcholki)))))))))
                 (T
                  (cond ((equal ename #cLINE)
                         (setq wierzcholki
                                (list (casc 10 (entget object)) (casc 11 (entget object)))
                               closed nil))
                        ((equal ename #cMLINE)
                         (setq wierzcholki (Mline->wierzcholki object)
                               closed      (checkClosedMline object)))
                        (T
                         (setq wierzcholki nil
                               closed nil)))
                  (if wierzcholki
                    (progn (while (< &l (length wierzcholki))
                             (setq dist (+ dist (distred (nth (1- &l) wierzcholki) (nth &l wierzcholki)))
                                   &l   (1+ &l)))
                           (if closed
                             (setq dist (+ dist (distred (car wierzcholki) (last wierzcholki)))))))))))
  dist)

(defun ssadd->list  (ss / result l)
  (if (and ss (> (sslength ss) 0))
    (progn (setq l 0)
           (while (< l (sslength ss))
             (setq result (append result (list (ssname ss l)))
                   l      (1+ l)))))
  result)

(defun kontur->enklawa  (object findLayer / wierzcholki k res)
  (if (setq wierzcholki
             (cond ((eq (casc 0 (entget object)) #cPOLYLINE) (polyline->wierzcholki object))
                   (T (LWPolyline->wierzcholki object))))
    (if (setq si (ssget "_WP" wierzcholki (list (cons 0 #cPOLYLINE) (cons 8 findLayer))))
      (progn (setq k   0
                   res '())
             (while (< k (sslength si))
               (if (checkClosedPolyline (ssname si k))
                 (setq res (append res (list (ssname si k)))))
               (setq k (1+ k)))
             res))
    '()))

(defun dzialka->enklawa (object / wierzcholki) (kontur->enklawa object "EDZPD"))

(defun dz-pow  (plin)
  (if #GSTAR
    (arxGetArea plin)
    (vla-get-area (vlax-ename->vla-object plin))))

(defun dzialka->powierzchnia  (object szukajEnklaw / _ret pp ss)
  (cond (szukajEnklaw
         (cond ((and (setq ss (dzialka->enklawa object)) (> (length ss) 0))
                (if !command-s
                  (command-s "_.AREA" "_A" "_O" object "" "_S" "_O")
                  (command "_.AREA" "_A" "_O" object "" "_S" "_O"))
                (foreach & ss
                   (vl-cmdf &))
                (vl-cmdf "" "")               
                (setq _ret (getvar "AREA")))
               (T (setq _ret (dz-pow object)))))
        (T (setq _ret (dz-pow object))))
  _ret)

(defun dzialka->Pow_PowZ  (pline szEnklaw &powZr / uklad m0 src Ygk Xgk u v q0 q1 q2 q3 q4 u2 v2 qq m popr _pz_)
  (setq uklad (dwg_uklad)
        pw    (dzialka->powierzchnia pline szEnklaw))
  (set &powZr pw)
  (if (and (> uklad 6) (< uklad 11))
    (progn (setq m0   0.999923
                 src  (srodek_ciezkosci pline)
                 Xgk  (/ (cadr src) m0)
                 Ygk  (/ (- (car src) (+ (* (- uklad 2) 1000000.0) 500000.0)) m0)
                 u    (* (- Xgk 5800000.0) 2.0 1E-6)
                 v    (* Ygk 2.0 1E-6)
                 q0   -7.7
                 q1   306.752873
                 q2   -0.312616
                 q3   0.006382
                 q4   0.158591
                 u2   (* u u)
                 v2   (* v v)
                 qq   (+ q0 (* m0 v2 (+ q1 (* q2 u) (* q3 u2) (* q4 v2))))
                 m    (+ (* qq 1E-5) 1.0)
                 popr (* pw (- (* m m) 1.0))
                 _pz_ (- pw popr))
           (set &powZr _pz_)))
  pw)

(defun ed_odn_podkr  (pLod pAtt isLod secObj / p e od pk kn lPoints ht)
  (if (and pLod (entget pLod))
    (progn (setq p  (entnext pLod)
                 e  (entget pAtt)
                 od (casc 10 (entget p)))
           (if (= (casc 0 e) #cINSERT)
              (setq pk (_wspOdnAny pAtt))
              (setq ht (casc 40 e)
                   pk (_wspOdn pAtt)))     
           (setq kn (cadr pk)
                 pk (car pk))
           (if isLod
             (progn (if (< (distred pk od) (distred kn od))
                      (_swap 'kn 'pk))
                    (setq lPoints (list od kn pk)))
             (setq lPoints (list kn pk)))     
           (vla-put-Coordinates (vlax-ename->vla-object pLod) (listaPunktow->variantArray_3D lPoints))
           (if secObj
             (vla-put-Coordinates
               (vlax-ename->vla-object secObj)
               (listaPunktow->variantArray_3D
                 (list (polar pk (- (angle pk kn) #pi2) (* #wsp (/ ht 4)))
                       (polar kn (- (angle pk kn) #pi2) (* #wsp (/ ht 4))))))))))

(defun edytuj_odnosnik (item attr) (ed_odn_podkr item attr T nil))

(defun edytuj_podkreslenie (item attr sec) (ed_odn_podkr item attr nil sec))

(defun odnosnik_podkreslenie  (pmain pnext / link mod)
  (if (= (casc 0 (entget pmain)) #cINSERT)
    (setq mod (eq (entnext pmain) pnext))
    (setq mod T))
  (if mod
    (progn (if (setq link (get_link (read_exdata pmain) "LOD"))
             (edytuj_odnosnik link pnext))
           (if (setq link (get_link (read_exdata pmain) "PODK"))
             (edytuj_podkreslenie link pnext (get_link (read_exdata pmain) "PODK1")))
           (if (and edytuj_jajo (setq link (get_link (read_exdata pmain) "ELIS")))
             (edytuj_jajo link pnext)))))

(defun _getpoly  (pa filter / ppoly pnext ss ssp l plin)
  (if (setq ppoly (br_bpoly pa))
    (progn (setq pnext ppoly)
           (if (setq ss (GetCEn (casc 10 (entget (entnext ppoly))) 0.1 (list (cons 0 #cPOLYLINE)) filter))
             (progn (while (and (> (sslength ss) 1) (/= (casc 0 (entget (setq pnext (entnext pnext)))) #cSEQEND))
                      (if (setq ssp (GetCEn (casc 10 (entget pnext)) 0.05 (list (cons 0 #cPOLYLINE)) filter))
                        (progn (setq l 0)
                               (while (< l (sslength ss))
                                 (if (not (ssmemb (ssname ss l) ssp))
                                   (ssdel (ssname ss l) ss))
                                 (setq l (1+ l))))))
                    (setq plin (ssname ss 0))
                    (redraw)))
           (entdel ppoly)
      ))
  (_mnil '(ppoly pnext ss ssp l))
  plin)

(defun _findkont  (nr elist prom / ss en l ok)
  (setq ok nil
        l  0)
  (if (setq ss (ssget "_X" elist))
    (while (and (null ok) (< l (sslength ss)))
      (setq en (ssname ss l)
            l  (1+ l)
            ok (cond ((= (casc 0 (entget en)) #cTEXT) (= (casc 1 (entget en)) nr))
                     ((= (casc 0 (entget en)) #cINSERT) (= (casc 1 (entget (entnext en))) nr))
                     ((= (casc 0 (entget en)) #cMTEXT) (= (casc 1 (entget en)) nr))
                     (T nil)))))
  (_mnil '(ss l))
  (if ok
    en
    (progn (princ (strcat "\nNie odnaleziono " prom " " nr ".")) nil)))

(defun okno_data  (ret_wiersze godlo / result lopis id_dcl _wykaz l myaction wiersze _kon _act _sp)
  (defun _sp  (s)
    (cond ((eq s "") " ")
          (T s)))
  (defun _kon  (&var)
    (cond ((> &var 0)
           (setq len     (strlen (get_tile "wykaz"))
                 wiersze (list (_add (get_tile "wykaz") (fix (+ len (/ (- 72 len) 2))) T))
                 l       1)
           (mapcar '(lambda (&)
                      (if (= (get_tile (strcat "t" (itoa l))) "1")
                        (setq wiersze (append wiersze (list (strcat marg & ": " (get_tile (strcat "w" (itoa l))))))))
                      (setq l (1+ l)))
                   '("Rysunek" "Obiekt" "Operator" "Id opracowania" "Wykonawca" "Arkusz"))))
    (done_dialog &var))
  (defun _act  (var / a)
    (setq a (substr var 2 1)
          b (get_tile (strcat "t" a)))
    (mode_tile (strcat "w" a)
               (if (= b "1")
                 0
                 1)))
  (setq result  nil
        wiersze (eval ret_wiersze)
        _wykaz  (vl-string-left-trim " " (car wiersze))
        lopis   (list (list "1" (_getDwgName))
                      (list "1" (dwg_Opis))
                      (list "1" (dwg_USR))
                      (list "1" (dwg_KRG))
                      (list "1" (arxFirma))
                      (list (if godlo
                              "1"
                              "0")
                            (if godlo
                              godlo
                              ""))))
  (if (and (>= (setq id_dcl (load_dialog #msg_dcl_file)) 0) (new_dialog "data" id_dcl))
    (progn (set_tile "wykaz" _wykaz)
           (setq l 1)
           (mapcar '(lambda (&)
                      (set_tile (strcat "w" (itoa l)) (cadr &))
                      (set_tile (strcat "t" (itoa l)) (car &))
                      (mode_tile (strcat "w" (itoa l))
                                 (if (= (car &) "1")
                                   0
                                   1))
                      (action_tile (strcat "t" (itoa l)) "(_act $key)")
                      (setq l (1+ l)))
                   lopis)
           (action_tile "accept" "(_kon 1)")
           (action_tile "cancel" "(_kon 0)")
           (setq myaction (start_dialog))
           (unload_dialog id_dcl)
           (cond ((= myaction 0) (setq result nil))
                 (T (set ret_wiersze wiersze) (setq result #msg_plik_tmp)))))
  result)

(defun get_currZoom  (/ ctr siz dx dy scrsize)
  (setq ctr     (getvar "VIEWCTR")
        siz     (getvar #viewsize)
        scrsize (getvar "SCREENSIZE")
        dy      (/ (* siz (/ (car scrsize) (cadr scrsize))) 2.0)
        dx      (/ siz 2.0))
  (list (list (- (car ctr) dy) (- (cadr ctr) dx)) (list (+ (car ctr) dy) (+ (cadr ctr) dx))))

(defun get_zoomPolyline  (plin &oldZoom / vts dx dy pmin pmax &)
  (if (eq (type (eval plin)) 'VLA-OBJECT)
    (setq plin (vlax-ename->vla-object plin)))
  (set &oldZoom (get_currZoom))
  (setq vts (Polyline->wierzcholki plin)
        pmin (car vts)
        pmax (last vts))
  (foreach & vts
    (if (< (car &) (car pmin))
      (setq pmin (list (car &) (cadr pmin))))
    (if (< (cadr &) (cadr pmin))
      (setq pmin (list (car pmin) (cadr &))))
    (if (> (car &) (car pmax))
      (setq pmax (list (car &) (cadr pmax))))
    (if (> (cadr &) (cadr pmax))
      (setq pmax (list (car pmax) (cadr &)))))
  (setq dy   (* (distance pmin (list (car pmax) (cadr pmin))) #wspolcz_getZoomPolyline)
        dx   (* (distance pmin (list (car pmin) (cadr pmax))) #wspolcz_getZoomPolyline))
  (list (list (- (car pmin) dy) (- (cadr pmin) dx)) (list (+ (car pmax) dy) (+ (cadr pmax) dx))))

(defun polyline->zoom  (pline / zoom)
  (setq zoom (get_zoomPolyline pline 'zoom))
  (arxZoomWindow (car zoom) (cadr zoom)))

(defun Polyline->ZoomMark (pline / obj) (_markObject pline) (polyline->zoom pline))

(defun srodek_ciezkosci  (obj / wierz l AllPow trk PowTrk pow wX wY powrot)
  (setq wierz  (polyline->wierzcholki obj)
        l      1
        AllPow 0.0
        trk    '()
        PowTrk '())
  (if (= (length wierz) 2)
    (setq powrot (srwsp (car wierz) (cadr wierz)))
    (progn (while (< l (1- (length wierz)))
             (setq wX     (/ (+ (car (nth 0 wierz)) (car (nth l wierz)) (car (nth (1+ l) wierz))) 3)
                   wY     (/ (+ (cadr (nth 0 wierz)) (cadr (nth l wierz)) (cadr (nth (1+ l) wierz))) 3)
                   pow    (- (* (- (car (nth l wierz)) (car (nth 0 wierz))) (- (cadr (nth (1+ l) wierz)) (cadr (nth 0 wierz))))
                             (* (- (car (nth (1+ l) wierz)) (car (nth 0 wierz))) (- (cadr (nth l wierz)) (cadr (nth 0 wierz)))))
                   pow    (/ pow 2.0)
                   trk    (append trk (list (list wX wY)))
                   PowTrk (append PowTrk (list pow))
                   AllPow (+ AllPow pow)
                   l      (1+ l)))
           (setq wX 0.0
                 wY 0.0)
           (if (= AllPow 0.0)
             (progn (foreach &  wierz
                      (setq wX (+ wX (car &))
                            wY (+ wY (cadr &))))
                    (setq wX (/ wX (length wierz))
                          wY (/ wY (length wierz))))
             (mapcar '(lambda (ww pp)
                        (setq wX (+ wX (* (car ww) (/ pp AllPow)))
                              wY (+ wY (* (cadr ww) (/ pp AllPow)))))
                     trk
                     PowTrk))
           (setq powrot (list wX wY))))
  powrot)

(defun zoomObject (obik / zmin zmax)
  (ename->vlaObj 'obik)
  (vla-GetBoundingBox obik 'zmin 'zmax)
  (setq zmin (vlax-safearray->list zmin)
        zmax (vlax-safearray->list zmax))
  (arxZoomWindow zmin zmax))

(defun safearray-points  (points / retList pk)
  (setq retList '())
  (if (type points)
    (if (not (vl-catch-all-error-p
               (setq points (vl-catch-all-apply 'vlax-safearray->list (list (vlax-variant-value points))))))
      (progn (repeat (/ (length points) 3)
               (setq pk      (list (car points))
                     points  (cdr points)
                     pk      (append pk (list (car points)))
                     points  (cdr points)
                     pk      (append pk (list (car points)))
                     points  (cdr points)
                     retList (append retList (list pk)))))))
  retList)

(defun centroid  (obj / res pmin pmax len sr lin pts i pt osm)
  (setq osm (getvar #osmode))
  (setvar #osmode 0)
  (cond ((in (casc 0 (entget obj)) (list #cINSERT #cTEXT #cMTEXT #cCIRCLE)) (setq res (casc 10 (entget obj))))
        ((in (casc 0 (entget obj)) (list #cPOLYLINE #cLWPOLYLINE #cMLine))
         (if (checkClosedPolyline obj)
           (progn             
         (setq res (srodek_ciezkosci obj)
               sr  res)                  
         (if (null (arx_inpoly res obj))
           (progn (vla-GetBoundingBox (vlax-ename->vla-object obj) 'pmin 'pmax)
                  (setq len  20000.0
                        pmin (vlax-safearray->list pmin)
                        pmax (vlax-safearray->list pmax))
                  (foreach &  (list pmin pmax (list (car pmin) (cadr pmax)) (list (car pmax) (cadr pmin)))
                    (setq lin (vla-addLine #ModelS (vlax-3D-point &) (vlax-3D-point res)))
                    (vla-put-visible lin :vlax-false)
                    (setq pts (safearray-points (vla-IntersectWith lin (vlax-ename->vla-object obj) acExtendNone)))
                    (entdel (vlax-vla-object->ename lin))
                    (if (> (length pts) 1)
                      (progn (setq i 0)
                             (repeat (1- (length pts))
                               (setq pt (srwsp (nth i pts) (nth (1+ i) pts)))
                               (if (and (arx_inpoly pt obj) (< (distred pt sr) len))
                                 (setq res pt
                                       len (distred pt sr)))
                               (setq i (1+ i)))))))))
           (progn
             (setq pts (polyline->wierzcholki obj)
                   i (msg_div (length pts) 2)
                   res (SrWsp (nth i pts) (nth (1- i) pts)))
           )))  
        (T (setq res nil)))
  (setvar #osmode osm)
  res)

(defun _:  (a b)
  (cond ((= b 0) 0)
        (T (/ a b))))

(defun _inline  (a b c)
  (and (not (equal a b))
       (not (equal a c))
       (equal (_: (- (car a) (car b)) (- (cadr a) (cadr b)))
              (_: (- (car a) (car c)) (- (cadr a) (cadr c)))
              0.0001)
       (equal (distance a b) (+ (distance a c) (distance c b)) 0.001)))

(defun checkClosedPolyline  (plin)
  (cond ((= (casc 0 (entget plin)) #cMLINE)
         (checkClosedMline plin))
        ((in (casc 0 (entget plin)) (list #cPOLYLINE #cLWPOLYLINE))
          (cond ((or #Toolkit #GSTAR) (> (logand (casc 70 (entget plin)) 1) 0))
              (T
               (or (= (vla-get-Closed (vlax-ename->vla-object plin)) :vlax-true)
                   (= (vla-get-Closed (vlax-ename->vla-object plin)) -1))))
          )
        (T nil)) )

(defun checkClosedMline (plin) (> (casc 71 (entget plin)) 1))

(defun msg_setcfg  (param_name param_value)
  (setcfg (strcat "AppData/" #msg_app "/" param_name) param_value))

(defun msg_getcfg  (param_name param_default / result)
  (if (or (null (setq result (getcfg (strcat "AppData/" #msg_app "/" param_name))))
          (and (equal (type result) 'STR) (= (strlen result) 0)))
    (setq result param_default))
  result)

(defun equal_polyline  (item1 item2 / l1 l2 ok)
  (setq l1 (Polyline->wierzcholki item1)
        l2 (Polyline->wierzcholki item2)
        ok (and l1 l2 (= (length l1) (length l2))))
  (if ok
    (foreach &  l1
      (if (not (member & l2))
        (setq ok nil))))
  ok)

(defun msg_div (a b) (fix (/ a b)))

(defun msg_mod (a b) (- a (* (msg_div a b) b)))

(defun EdycjaAtrybutowBloku  (latr prop code ilWierszy / dcl_id l k iname _makeDcl plik_dcl do_end do_enter sSet lst)
  (defun _makeDcl  (/ _c result atr)
    (setq result nil
          l      1
          _c     (chr 34))
    (if (and (setq plik_dcl (vl-filename-mktemp "" "" ".dcl"))
             (msg_open_fle plik_dcl "w")
             (include_baseDcl #fle))
      (progn (write-line
               (strcat "atrybuty_bloku:dialog{label=" _c "Atrybuty opisowe" _c ";initial_focus=" _c "e1" _c ";:boxed_column{fixed_width=true;children_alignment = right;")
               #fle)
             (foreach &  latr
               (setq atr (cond ((listp &) (car &))
                               (T &)))
               (write-line
                 (strcat ":edit_box{label=" _c atr ":" _c ";edit_width=20;key=" _c "e" (itoa l) _c ";}")
                 #fle)
               (if ilWierszy
                 (progn (setq k 1)
                        (repeat (- ilWierszy 1)
                          (write-line
                            (strcat ":edit_box{label=" _c _c ";edit_width=20;key=" _c "e" (itoa l) "w" (itoa k) _c ";}")
                            #fle)
                          (setq k (1+ k)))))
               (setq l (1+ l)))
             (write-line "spacer;}spacer;msg_ok_cancel_help;}" #fle)
             (msg_close_fle)
             (setq result T)))
    result)
  (defun do_enter  (reason key / idx)
    (if (= reason 1)
      (progn (setq idx (1+ (atoi (substr key 2))))
             (cond ((> idx (length latr)) (do_end 1))
                   (T (mode_tile (strcat "e" (itoa idx)) 2))))))
  (defun do_end  (var / sRes s k)
    (if (> var 0)
      (progn (setq l 1)
             (repeat (length latr)
               (if ilWierszy
                 (progn (setq sRes (get_tile (strcat "e" (itoa l))))
                        (setq k 1)
                        (repeat (- ilWierszy 1)
                          (setq s (get_tile (strcat "e" (itoa l) "w" (itoa k)))
                                k (1+ k))
                          (if (/= s "")
                            (setq sRes (strcat sRes "\n" s))))
                        (setq iname (append iname (list sRes))))
                 (setq iname (append iname (list (get_tile (strcat "e" (itoa l)))))))
               (setq l (1+ l)))))
    (setq #scr-pt (done_dialog var)))
  (setq iname '())
  (if (and latr (> (length latr) 0))
    (cond (#aktywny_dialog
           (if (and (_makeDcl)
                    (>= (setq dcl_id (load_dialog plik_dcl)) 0)
                    (new_dialog "atrybuty_bloku" dcl_id "" #scr-pt))
             (progn (setq l 1)
                    (repeat (length latr)
                      (setq sSet (cond (prop
                                        (if (listp prop)
                                          (car prop)
                                          (if (= l 1)
                                            #nr_pik
                                            "")))
                                       ((listp (nth (- l 1) latr)) (cadr (nth (- l 1) latr)))
                                       (T "")))
                      (if (and ilWierszy (vl-string-position (ascii "\n") sSet))
                        (progn (setq lst (_podziel_znak sSet "\n")
                                     k   0)
                               (set_tile (strcat "e" (itoa l)) (car lst))
                               (foreach & (cdr lst) (set_tile (strcat "e" (itoa l) "w" (itoa (1+ k))) &) (setq k (1+ k))))
                        (set_tile (strcat "e" (itoa l)) sSet))
                      (action_tile (strcat "e" (itoa l)) "(do_enter $reason $key)")
                      (setq l (1+ l)))
                    (if (= (strlen code) 0)
                      (mode_tile "help" 1))
                    (action_tile "help" "(showHelp code)")
                    (action_tile "accept" "(do_end 1)")
                    (action_tile "cancel" "(do_end 0)")
                    (start_dialog)
                    (unload_dialog dcl_id)
                    (vl-file-delete plik_dcl))
             (setq iname nil)))
          (T
           (foreach &  latr
             (setq name (getstring 1
                                   (strcat "\n"
                                           &
                                           (if prop
                                             (if (listp prop)
                                               (strcat " [" (car prop) "]")
                                               (strcat " [" #nr_pik "]"))
                                             "")
                                           ": ")))
             (if (and prop (= name ""))
               (if (listp prop)
                 (setq name (car prop))
                 (setq name #nr_pik)))
             (setq iname (append iname (list name)))))))
  iname)

(defun edycja_slownika  (idx &lista / _id lista editTxt wnext do_box do_end do_add do_edit)
  (defun do_box  (val / stat)
    (setq stat (if (> (atoi val) -1)
                 0
                 1))
    (mode_tile "repl" stat)
    (mode_tile "del" stat))
  (defun do_end  (var)
    (if (> var 0)
      (progn (setq idx     (get_tile "box")
                   editTxt (get_tile "edit"))))
    (setq #s-slwonik (done_dialog var)))
  (if (= (type idx) 'INT)
    (setq idx (itoa idx)))
  (setq wnext 2
        lista (eval &lista))
  (var_initialize '#s-slwonik '(-1 -1))
  (if (>= (setq _id (load_dialog #msg_dcl_file)) 0)
    (progn (while (and (> wnext 1) (new_dialog "slownik" _id "" #s-slwonik))
             (start_list "box")
             (mapcar 'add_list lista)
             (end_list)
             (set_tile "box" idx)
             (do_box idx)
             (action_tile "box" "(do_box $value)")
             (action_tile "add" "(do_end 2)")
             (action_tile "repl" "(do_end 3)")
             (action_tile "del" "(do_end 4)")
             (action_tile "accept" "(do_end 1)")
             (action_tile "cancel" "(do_end 0)")
             (setq wnext (start_dialog))
             (cond ((= wnext 2)
                    (if (and (> (strlen editTxt) 0) (null (member editTxt lista)))
                      (setq lista (append lista (list editTxt)))))
                   ((= wnext 3)
                    (if (and (> (strlen editTxt) 0) (> (atoi idx) -1))
                      (setq lista (change_item_lst (atoi idx) editTxt lista))))
                   ((= wnext 4)
                    (if (> (atoi idx) -1)
                      (setq lista (vl-remove (nth (atoi idx) lista) lista))))))
           (unload_dialog _id)))
  (set &lista lista)
  idx)

(defun EdycjaAtrybutowBloku1  (&Atrybuty code / latr dcl_id l iname iList iVal _makeDcl plik_dcl do_end do_enter do_slownik)
  (defun _makeDcl  (/ _c l result atr)
    (setq result nil
          l      1
          _c     (chr 34))
    (if (and (setq plik_dcl (vl-filename-mktemp "" "" ".dcl"))
             (msg_open_fle plik_dcl "w")
             (include_baseDcl #fle))
      (progn (write-line (strcat "atrybuty_bloku:dialog{label=" _c "Atrybuty opisowe" _c
                                 ";initial_focus=" _c "e1" _c
                                 ";:boxed_column{fixed_width=true;children_alignment = right;")
                         #fle)
             (foreach &  latr
               (setq atr (cond ((listp &) (car &))
                               (T &)))
               (if (listp (cadr &))
                 (write-line (strcat ":row{:popup_list{label="
                                     _c
                                     atr
                                     ":"
                                     _c
                                     ";edit_width=10;key="
                                     _c
                                     "e"
                                     (itoa l)
                                     _c
                                     ";}:retirement_button{label="
                                     _c
                                     "Sownik..."
                                     _c
                                     ";key="
                                     _c
                                     "sl"
                                     (itoa l)
                                     _c
                                     ";}}")
                             #fle)
                 (write-line (strcat ":edit_box{label=" _c atr ":" _c ";edit_width=20;key=" _c "e" (itoa l) _c ";}")
                             #fle))
               (setq l (1+ l)))
             (write-line "spacer;}spacer;msg_ok_cancel_help;}" #fle)
             (msg_close_fle)
             (setq result T)))
    result)
  (defun do_enter  (reason key / idx)
    (if (= reason 1)
      (progn (setq idx (1+ (atoi (substr key 2))))
             (cond ((> idx (length latr)) (do_end 1))
                   (T (mode_tile (strcat "e" (itoa idx)) 2))))))
  (defun do_end  (var / l iVal item)
    (if (> var 0)
      (progn (setq l     1
                   iname '())
             (repeat (length latr)
               (setq item (get_tile (strcat "e" (itoa l))))
               (if (and (cadr (nth (- l 1) latr)) (listp (cadr (nth (- l 1) latr))))
                 (progn (setq latr (change_item_lst (- l 1) (list (car (nth (- l 1) latr)) (list item (nth (- l 1) iList))) latr)
                              item (nth (atoi item) (nth (- l 1) iList)))
                        (set &Atrybuty latr)))
               (setq iname (append iname (list item))
                     l     (1+ l)))))
    (setq #scr-pt (done_dialog var)))
  (defun do_slownik  (key / ik %lst)
    (setq ik   (substr key 3)
          %lst (nth (- (atoi ik) 1) iList))
    (if (and %lst (listp %lst) (setq ii (edycja_slownika -1 '%lst)))
      (progn (start_list (strcat "e" ik))
             (mapcar 'add_list %lst)
             (end_list)
             (set_tile (strcat "e" ik) ii)
             (setq iList (change_item_lst (- (atoi ik) 1) %lst iList)))))
  (setq latr (eval &Atrybuty))
  (if (and latr (> (length latr) 0))
    (progn
      (if (and (_makeDcl)
               (>= (setq dcl_id (load_dialog plik_dcl)) 0)
               (new_dialog "atrybuty_bloku" dcl_id "" #scr-pt))
        (progn (setq l     1
                     iList '())
               (repeat (length latr)
                 (if (listp (nth (- l 1) latr))
                   (progn (setq iVal (cadr (nth (- l 1) latr)))
                          (if iVal
                            (progn (if (listp iVal)
                                     (progn (setq iList (append iList (list (cadr iVal))))
                                            (start_list (strcat "e" (itoa l)))
                                            (mapcar 'add_list (cadr iVal))
                                            (end_list)
                                            (action_tile (strcat "sl" (itoa l)) "(do_slownik $key)")
                                            (set_tile (strcat "e" (itoa l)) (car iVal)))
                                     (progn (set_tile (strcat "e" (itoa l)) iVal) (setq iList (append iList (list " "))))))
                            (set_tile (strcat "e" (itoa l)) "")))
                   (progn (set_tile (strcat "e" (itoa l)) "") (setq iList (append iList (list " ")))))
                 (setq l (1+ l)))
               (if (= (strlen code) 0)
                 (mode_tile "help" 1))
               (action_tile "help" "(showHelp code)")
               (action_tile "accept" "(do_end 1)")
               (action_tile "cancel" "(do_end 0)")
               (start_dialog)
               (unload_dialog dcl_id)
               (vl-file-delete plik_dcl))
        (setq iname nil))))
  iname)

(defun _jedenWylacz  (key value)
  (cond ((and (eq key "odnosnik") (eq value "1")) (set_tile "podkresl" "0"))
        ((and (eq key "podkresl") (eq value "1")) (set_tile "odnosnik" "0"))))

(defun dialog_tekst  (opis &return_str / _id _ret)
  (if (and (>= (setq _id (load_dialog #msg_dcl_file)) 0)
           (new_dialog "dialog_tekst" _id "" #scr-pt-okno-tekst))
    (progn
      (set_tile "prompt" (strcat opis ":"))
      (set_tile "podkresl" #txt_pod)
      (set_tile "odnosnik" #txt_lod)
      (_jedenWylacz "odnosnik" #txt_lod)
      (set_tile "txt" (eval &return_str))
      (action_tile "odnosnik" "(_jedenWylacz $key $value)")
      (action_tile "podkresl" "(_jedenWylacz $key $value)")
      (action_tile
        "accept"
        "(setq _ret (get_tile \"txt\"))
	                     (set &return_str _ret)
                             (setq #txt_pod (get_tile \"podkresl\")
	                           #txt_lod (get_tile \"odnosnik\")
                                   #scr-pt-okno-tekst (done_dialog))")
      (action_tile "cancel" "(progn(setq _ret \"\")(done_dialog))")
      (start_dialog)
      (unload_dialog _id))
    (setq _ret (getstring 1 (strcat "\n" opis ": "))))
  _ret)

(defun ssunion  (ss1 ss2 / _ii)
  (cond ((and ss1 ss2)
         (foreach _ii (ssadd->list ss2) (ssadd _ii ss1))
         ss1
        )
        (ss1 ss1)
        (ss2 ss2)
        (T nil)))

(defun ssdiff  (ss1 ss2 / hilite ss3 l ok)
  (cond ((and ss1 ss2)
         (if (= (sslength ss1) (sslength ss2))
           (progn (setq ok T
                        l  0)
                  (while (and ok (< l (sslength ss2)))
                    (setq ok (ssmemb (ssname ss2 l) ss1)
                          l  (1+ l)))))
         (if ok
           (setq ss3 ss1)
           (if ss1
             (progn (setq hilite (getvar "HIGHLIGHT"))
                    (setvar "HIGHLIGHT" 0)
                    (if !command-s
                      (command-s "_.SELECT" ss1 "_R" ss2 "")
                      (command "_.SELECT" ss1 "_R" ss2 ""))
                    (setq ss3 (ssget "_P"))
                    (setvar "HIGHLIGHT" hilite))
             (setq ss3 nil)))
         ss3)
        (T
         (if ss1
           ss1
           ss2))))

(defun ssinter  (ss1 ss2 / count count1 count2 smax smax1 smax2 more less name hilite ss3)
  (setq count  0
        count1 0
        count2 0
        smax1  (sslength ss1)
        smax2  (sslength ss2)
        ss3    (ssadd))
  (if (>= count1 count2)
    (setq more ss1
          less ss2
          smax smax1)
    (setq more ss2
          less ss1
          smax smax2))
  (while (< count smax)
    (setq name (ssname more count))
    (if (ssmemb name less)
      (ssadd name ss3))
    (setq count (1+ count)))
  ss3)

(defun include_baseDcl  (fout / fin linia _ret plik)
  (setq plik (findfile #msg_base_dcl))
  (if (and plik (setq fin (open plik "r")))
    (progn (while (setq linia (read-line fin)) (write-line linia fout)) (close fin) (setq _ret T)))
  _ret)

(defun setvarIf  (var value)
  (if (/= (getvar var) value)
    (setvar var value)))

(defun SpaceIfZero  (v)
  (if (/= (distof v) 0)
    v
    " "))

(defun KreskaIfZero  (v)
  (if (/= (distof v) 0)
    v
    (if (eq #lst_kres "1")
      "-"
      " ")))

(defun code->value  (code / opis_kodu)
  (if (and code (setq opis_kodu (WydajKod (strcase code))))
    (caddr opis_kodu)
    (if (setq opis_kodu (opis_atrybutu code))
      (caddr opis_kodu)
      "")))

(defun full_code  (fcode / cf)
  (if (and (> (strlen fcode) 0) (setq cf (WydajKod fcode)))
    (strcat fcode " (" (itoa (last cf)) ")")
    fcode))

(defun displayZrodlo  (zrd krg)
  (if (= (vl-registry-read #msgKlucz "ModeMacro") "0")
    (setvar "MODEMACRO" "")
    (progn (setq #lst_zrd zrd)
           (if (null krg)
             (setq krg (dwg_KRG)))
           (if (null (distof zrd))
             (progn (setq zrd (vl-position zrd #ltaBDZZRD))
                    (if zrd
                      (setq zrd (itoa zrd))
                      (setq zrd (itoa (dwg_zrd))))))
           (if (nth (atoi zrd) #ltaBDZZRD)
             (progn (if (null #GSTAR)
                      (setvar "MODEMACRO" (strcat "ZRD: " (nth (atoi zrd) #ltaBDZZRD) ", KRG: " krg)))
                    (msg_setcfg "Zrodlo" zrd)))))
  (princ))


(defun DwaTekstyWspolrz  (w ang _styl / s ht)
  (if (setq s (tblsearch "STYLE" _styl))
    (setq ht (casc 40 s))
    (setq ht 1.8))
  (list (polar w (+ ang #pi2) (/ ht 5.0)) (polar w (- ang #pi2) (/ ht 5.0))))

(defun skala_multilinii (nazwa / lst) #wsp)

(defun _setLinetype  (%ltype)
  (if (wczytajLinetype %ltype)
    (progn
      (setvar "CELTYPE" %ltype)
      T)
    nil))

(defun _getCurrDate  (/ dtm)
  (setq dtm (rtos (getvar "CDATE") 2 0))
  (strcat (substr dtm 1 4) "-" (substr dtm 5 2) "-" (substr dtm 7 2)))

(defun check_isSelected  (buttons message / _ret)
  (setq _ret (not (vl-every '(lambda (vv) (= (atoi (get_tile vv)) 0)) buttons)))
  (rs_error)
  (if (null _ret)
    (progn (msg_beep_reaction) (set_tile "error" message)))
  _ret)

(defun date_convert  (dd / r)
  (setq r (_podziel_znak dd ".")
        r (+ (atof (car r)) (* (atof (cadr r)) 1E2) (* (atof (caddr r)) 1E4)))
  r)

(defun in_date  (data data_od data_do)
  (cond ((eq (strlen data) 0) nil)
        (T
         (and (>= (date_convert data) (date_convert data_od))
              (<= (date_convert data) (date_convert data_do))))))

(defun string->Def-If-Empty  (s def)
  (if (or (null s) (= (strlen s) 0))
    def
    s))

(defun readParamsFile  (plik parName parDefault / plik ok linia _ret)
  (setq _ret parDefault)
  (if (setq #fle (open plik "r"))
    (progn (setq ok nil)
           (while (and (null ok) (setq linia (read-line #fle)))
             (if (setq ok (= (strcase (StrLeftValue linia)) (strcase parName)))
               (setq _ret (StrRightValue linia))))
           (msg_close_fle)))
  _ret)

(defun writeParamsFile  (plik parName parValue / nplik f linia nlinia ok)
  (setq ok    nil
        nplik (strcat (vl-filename-directory plik)
                      "\\"
                      (vl-filename-base plik)
                      (substr (vl-filename-extension plik) 1 3)
                      "_"))
  (if (setq #fle (open plik "r"))
    (if (setq f (open nplik "w"))
      (progn (while (setq linia (read-line #fle))
               (if (_pos "=" linia)
                 (progn (setq nlinia (_podziel_znak linia "="))
                        (if (= (strcase (car nlinia)) (strcase parName))
                          (setq ok    T
                                linia (strcat (car nlinia) "=" parValue)))))
               (write-line linia f))
             (if (null ok)
               (progn (write-line (strcat parName "=" parValue) f) (setq ok T)))
             (msg_close_fle)
             (close f)
             (setq ok (and (vl-file-delete plik) (vl-file-rename nplik plik)))))
    (if (setq #fle (open plik "w"))
      (progn (write-line (strcat parName "=" parValue) #fle) (msg_close_fle) (setq ok T))))
  ok)

(defun read_msgini  (par def / ini)
  (if (setq ini (findfile "msg.ini"))
    (readParamsFile ini par def)
    def))

(defun write_msgini  (par value / ini)
  (if (setq ini (findfile "msg.ini"))
    (writeParamsFile ini par value)))

(defun writeUSERS (name value) (writeParamsFile (strcat (_getFullDwgName) ".par") name value))

(defun readUSERS (name default) (readParamsFile (strcat (_getFullDwgName) ".par") name default))

(defun var_initialize  (&value default)
  (if (null (eval &value))
    (set &value default)))

(defun in_Int (v lv) (and (>= v (car lv)) (<= v (cadr lv))))

(defun _insertAngle  (blok pk ang)
  (definiuj_blok blok nil)
  (if (null ang)
    (prompt "\nKt obrotu: "))
  (command #c_INSERT blok pk #wsp #wsp)
  (cond (ang (vl-cmdf ang))
        (T (vl-cmdf PAUSE))))

(defun _inPaperSpace  (object / _ret e330)
  (and (assoc 67 (entget object)) (eq (casc 67 (entget object)) 1)))

(defun _markSelected  (ss / l)
  (setq l 0)
  (while (< l (sslength ss)) (redraw (ssname ss l) 3) (setq l (1+ l))))

(defun uzupelnijListe  (&lista dlugosc)
  (while (< (length (eval &lista)) dlugosc) (set &lista (append (eval &lista) '("")))))

(defun msg_getdir (tile path) (msg_SelectDir tile path))

(defun msg-string-remove  (str char)
  (while (vl-string-search char str) (setq str (vl-string-subst "" char str)))
  str)

(defun msg-string-subst  (charnew charold str)
  (while (vl-string-search charold str) (setq str (vl-string-subst charnew charold str)))
  str)

(defun msg-string-expand  (s / return l len)
  (setq return ""
        l      1
        len    (strlen s))
  (while (<= l len)
    (setq return (cond ((eq l 1) (substr s 1 1))
                       (T (strcat return " " (substr s l 1))))
          l      (1+ l)))
  return)

(defun StrLeftValue  (ss / p)
  (if (setq p (vl-string-position (ascii "=") ss))
    (substr ss 1 p)
    ss))

(defun StrRightValue  (ss / p)
  (if (setq p (vl-string-position (ascii "=") ss))
    (substr ss (+ p 2) (strlen ss))
    ss))

(defun LongInc (nazwa skok / nOfs nSeg MAXOFS do) (rtos (+ (atof nazwa) skok) 2 0))

(defun arxFirma () (vl-registry-read #msgKlucz "Firma"))	
(defun arxSerial () (vl-registry-read #msgKlucz "Serial"))
(defun arxUser () (vl-registry-read #msgKlucz "User"))
(defun arxVer  () (vl-registry-read #msgKlucz "Ver"))

(defun _laczObiekty  (&listaOb / isCof jeszcze obj exd lnk nowaPl prevObj result _wspolne)
  (defun _wspolne  (/ & hnds res obs)
    (setq obs (eval &listaOb))
    (if obs
      (progn (setq hnds (casc 5 (entget (car obs))))
             (foreach & (cdr obs) (setq hnds (strcat hnds SK_SEP (casc 5 (entget &)))))
             (setq res (arxJoinPline hnds))
             (if (> (strlen res) 0)
               (progn (if (vl-string-position (ascii "*") res)
                        (progn (setq res (substr res 1 (vl-string-position (ascii "*") res)))
                               (set &listaOb (del_last_lst (eval &listaOb)))))
                      (handent res))
               nil))
      nil))
  (set &listaOb (list))
  (setq #markObject nil
        isCof nil
        jeszcze T)
  (while jeszcze
    (cond (isCof (initget "Cofaj") (setq obj (entsel (strcat "\n" #Wskaz " obiekt albo [Cofaj]: "))))
          (T (setq obj (entsel #WskazObiekt))))
    (cond ((null obj)
           (if (dialog->yes_no "Potwierd koniec wyboru obiektw.")
             (setq jeszcze nil)))
          ((= obj "Cofaj") (setq isCof nil) (set &listaOb (del_last_lst (eval &listaOb))))
          ((eq (car obj) #markObject) (setq obj nil))
          (T
           (setq iscof T
                 obj   (car obj))
           (cond ((or (= (casc 0 (entget obj)) #cTEXT) (= (casc 0 (entget obj)) #cMTEXT) (= (casc 0 (entget obj)) #cINSERT))
                  (if (and (setq exd (read_exdata obj)) (setq lnk (get_link exd #cLINK)))
                    (setq obj lnk)
                    (setq obj nil)))
                 ((= (casc 0 (entget obj)) #cPOLYLINE)
                  (if (not (checkClosedPolyline obj))
                    (progn (prompt "\nObiekt nie jest zamknity...") (setq obj nil))))
                 (T (setq obj nil)))
           (if obj
             (set &listaOb (append (eval &listaOb) (list obj))))))
    (if Obj
      (progn (setq nowaPl (_wspolne))
             (if (and #markObject (entget #markObject))
               (cond (#Toolkit
                      (entdel #markObject))
                     (T (vla-delete (vlax-ename->vla-object #markObject)))))
             (setq #markObject nowaPl))))
  (if #markObject
    (progn (setq result (Polyline->Wierzcholki #markObject)) (entdel #markObject)(setq #markObject nil))
    (setq result nil))
  result)

(defun _jedenOb  (code &Clos / obj exd lnk kod nr cZ cW jesz)
  (setq cZ   "Kopia"
        cW   "wyMa"
        jesz T)
  (while jesz
    (initget (strcat cZ " " cW))
    (setq obj (entsel (if #selErase
                        (strcat "\nWska i wyma albo [" cZ "]: ")
                        (strcat "\nWska i skopiuj albo [" cW "]: "))))
    (cond ((= obj cZ) (setq #selErase nil))
          ((= obj cW) (setq #selErase T))
          (T (setq jesz nil))))
  (if obj
    (progn (setq obj (car obj))
           (cond ((or (= (casc 0 (entget obj)) #cTEXT) (= (casc 0 (entget obj)) #cMTEXT) (= (casc 0 (entget obj)) #cINSERT))
                  (if (and (setq exd (read_exdata obj)) (setq lnk (get_link exd #cLINK)))
                    (if (= (casc 0 (entget lnk)) #cPOLYLINE)
                      (setq obj lnk)
                      (setq obj nil))
                    (setq obj nil)))
                 ((or (= (casc 0 (entget obj)) #cPOLYLINE) (= (casc 0 (entget obj)) #cLWPOLYLINE))
                  (if (eval &Clos)
                    (if (not (checkClosedPolyline obj))
                      (progn (prompt "\nObiekt nie jest aman zamknit...") (setq obj nil))))
                  (if obj
                    (set &Clos (checkClosedPolyline obj))))
                 (T (setq obj nil)))

     (if (and obj (entget obj))
       (Polylinia->TypPunktu obj nil kodd))
      ))
  obj)

(defun LastPopMenuId  (/ i)
  (setq i 1)
  (while (menucmd (strcat "p" (itoa (setq i (1+ i))) ".1=?")) nil)
  (itoa i))

(defun _placeMenu  (menu mgroup / mGroups ext)
  (if (= (menugroup mgroup) mgroup)
    (princ)                             
    (progn (setq mGroups (vlax-get-property #acadApp 'MenuGroups))
           (cond (#GSTAR2016 (setq ext ".cuix"))
                 (#Brics (setq ext ".cui"))
                 (T
                  (if (> #AcadVer 17.2)
                    (setq ext ".cuix")
                    (setq ext ".cui"))))
           (if (setq menu (findfile (strcat menu ext)))
             (vla-Load mGroups menu))
           (if (menugroup mgroup)
             (menucmd (strcat "P" (LastPopMenuId) "=+" mgroup ".pop1")))))
  (princ))

;;;(defun _placeMenu  (menu mgroup / mGroups CNT ext)
;;;  (if (= (menugroup mgroup) mgroup)
;;;    (princ) ;(menucmd (strcat "P" (LastPopMenuId) "=+" mgroup ".pop1"))
;;;    (progn
;;;      (cond (#GSTAR2016
;;;             (setq ext ".cuix"))
;;;            (#Brics
;;;             (setq ext ".cui"))
;;;            (T
;;;             (if (> #AcadVer 17.2)
;;;               (setq ext ".cuix")
;;;               (setq ext ".cui"))))
;;;                 
;;;      (if (setq menu (findfile (strcat menu ext)))
;;;         (command "_MENULOAD" menu))
;;;      (if (menugroup mgroup)
;;;        (menucmd (strcat "P" (LastPopMenuId) "=+" mgroup ".pop1")))))
;;;  (princ))

(defun UkladKrakow ()
  (= (dwg_uklad) 12))

(defun Uklad->Wspolrz (p &wspx &wspy)
  (cond ((UkladKrakow)
         (set &wspx (- (cadr p)))
         (set &wspy (- (car p))))
        (T
         (set &wspx (cadr p))
         (set &wspy (car p)))))

(defun KrakowSwap (&pkr)
  (if (UkladKrakow)
    (setq &pkr (list (- (car &pkr)) (- (cadr &pkr)) (caddr &pkr))))
 &pkr)

(defun UstawLinetypeGeneration  (pline / lay lt laylt wykonac)
  (ename->vlaObj 'pline)
  (if #ZWCAD
    (setq wykonac (eq (vla-get-EntityName pline) "Polyline"))
    (setq wykonac (or (eq (vla-get-ObjectName pline) "AcDbPolyline") (eq (vla-get-ObjectName pline) "AcDb2dPolyline"))))
  (if wykonac
    (progn
      (if (or (/= (vla-get-Linetype pline) "ByLayer")
                   (/= (vla-get-linetype (vlax->Layer (vla-get-Layer pline))) #cContinuous))
             (vla-put-LinetypeGeneration pline :vlax-true)
             (vla-put-LinetypeGeneration pline :vlax-false))
           (vla-update pline))))

(defun NaprawPolyline2d (/ ss l len)
  (if (setq ss (ssget "_X" (list (cons 0 #cPOLYLINE))))
    (progn
      (setq l 0
            len (sslength ss))
      (while (< l len)
        (UstawLinetypeGeneration (ssname ss l))
        (setq l (1+ l)))
      (prompt (strcat "\n" (itoa len) " zmodyfikowanych."))))
  (princ))

(defun GetKolorWyroznienia (ktory def / path p)
  (setq path (getvar "LOCALROOTPREFIX"))
  (if (null (setq p (findfile (strcat path "msgV17.ini"))))
    (setq p (findfile (strcat path "\\msgV17.ini"))))
  (if p
    (atoi (readParamsFile p ktory def))
    (atoi def)))

(defun GetKolorWyroznienia1 (/ p)
  (GetKolorWyroznienia "KolorWyroznienia_1" "1"))

(defun GetKolorWyroznienia2 (/ p)
  (GetKolorWyroznienia "KolorWyroznienia_2" "2"))

(defun ExplodeHatch (/ ss)
  (if (setq ss (ssget "_X" '((0 . "HATCH"))))
    (if (> (sslength ss) 0)
      (if #Brics
        (vl-cmdf "_EXPLODE" ss)
        (if !command-s
          (command-s "_EXPLODE" ss "")
          (vl-cmdf "_EXPLODE" ss "")))))
  (princ))

(defun br_bpoly  (point / oldE newE)
  (cond (#Brics
         (setq oldE (entlast))
         (if !command-s
           (command-s "_-BOUNDARY" point "")
           (vl-cmdf "_-BOUNDARY" point ""))
         (setq newE (entlast))
         (if (eq oldE newE)
           (setq newE nil)))
        (#GSTAR8
         (setq oldE (entlast))
         (if !command-s
           (command-s "_-BOUNDARY" "A" "O" "P" "I" "N" "N" "" point "")
           (vl-cmdf "_-BOUNDARY" "A" "O" "P" "I" "N" "N" "" point ""))
         (setq newE (entlast))
         (if (equal oldE newE)
           (setq newE nil)))
        (T (setq newE (bpoly point))))
  newE)

(defun first-position (value lista / rLista item)
  (setq rLista '())
  (foreach & lista
    (setq item (_podziel &)
          rLista (append rLista (list (car item)))))
  (if (vl-position value rLista)
    (vl-position value rLista)
    0))

(defun GetMapaSGTempFolder ()
  (strcat (vl-registry-read "HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders" "AppData") "\\Mapsoft\\MapaSG"))

(defun TxtWysByVal  (obj idx / l pt Value _WysTxt)
  (defun _WysTxt  (Att Val / p)
    (setq p (getTextInsertionPoint Att)
          p (list (car p) (cadr p) (atof Val)))
    (msg-vla-put-TextInsertionPoint Att p))
  (ename->vlaObj 'obj)
  (cond ((= (casc 0 (entget (vlax-vla-object->ename obj))) #cINSERT)       
         (setq l 0)
         (if (arxHasAttributes (vlax-vla-object->ename obj))
           (foreach &  (vlax-safearray->list (vlax-variant-value (vla-getAttributes obj)))
             (setq Value (vla-get-TextString &))
             (if (distof Value)
               (progn (if (= l idx)
                        (progn (setq pt (vlax-safearray->list (vlax-variant-value (vla-get-InsertionPoint obj)))
                                     pt (list (car pt) (cadr pt) (atof Value)))
                               (vla-put-InsertionPoint obj (vlax-3d-point pt))))                 
                      (_WysTxt & Value)))
             (setq l (1+ l)))))
        ((or (= (casc 0 (entget (vlax-vla-object->ename obj))) #cTEXT)
             (= (casc 0 (entget (vlax-vla-object->ename obj))) #cMTEXT))
         (setq Value (vla-get-TextString obj))
         (if (distof Value)
           (_WysTxt obj Value)))))

(defun SetLntypeS  (plin / code skala)
  (if plin
    (progn (setq code (object->getCode plin)) (ZmianaRodzLin plin code))))

(defun arcsin  (sina)
  (if (= (- 1 (* sina sina)) 0.0)
    #pi2
    (atan (/ sina (sqrt (- 1 (* sina sina)))))))

(defun arccos (cosa)
  (if (>= cosa 0)
    (arcsin (sqrt (- 1 (* cosa cosa))))
    (- pi (arcsin (sqrt (- 1 (* cosa cosa)))))))

(defun xjMovRotOne  (obj flag / osm pt gr vObj _grAngle _grPoint)
  (defun _grAngle (a b) (grdraw (trans a 0 1) (cadr gr) -15 -1) (angle a b))
  (defun _grPoint (a b) (grdraw (trans a 0 1) (cadr gr) -15 -1) (vlax-3d-point b))
  (if (or (= (casc 0 (entget obj)) #cINSERT)
          (= (casc 0 (entget obj)) #cTEXT)
          (= (casc 0 (entget obj)) #cMTEXT))
    (progn (setq osm  (getvar #osmode)
                 vObj (vlax-ename->vla-object obj))
           (setvar #osmode 0)
           (if (= (get_status_value flag 1) 1)
             (progn (if (and (= (casc 0 (entget obj)) #cINSERT) (arxHasAttributes obj))
                      (setq vObj (vlax-ename->vla-object (entnext obj))))
                    (prompt "\nPunkt wstawienia: ")
                    (while (eq 5 (car (setq gr (grread T 15 0))))
                      (setq pt (trans (cadr gr) 1 0))
                      (redraw)
                      (if (eq (vla-get-Alignment vObj) acAlignmentLeft)
                        (vla-put-InsertionPoint vObj (_grPoint (vlax-get vObj 'InsertionPoint) pt))
                        (vla-put-TextAlignmentPoint vObj (_grPoint (vlax-get vObj 'TextAlignmentPoint) pt))))))
           (if (= (get_status_value flag 2) 1)
             (progn (prompt "\nKt obrotu: ")
                    (while (eq 5 (car (setq gr (grread T 15 0))))
                      (setq pt (trans (cadr gr) 1 0))
                      (redraw)
                      (vla-put-rotation vObj (_grAngle (vlax-get vObj 'InsertionPoint) pt)))))
           (redraw)
           (setvar #osmode osm)))
  (princ))

(defun xjMovRot  (obs flag / vObj isTxt isMText insP newP osm ptb obj & movObs)
  (setq movObs (ssadd))
  (if (null (listp obs))
    (setq obs (list obs)))
  (foreach & obs
    (ssadd & movObs))
  (setq obj (ssname movObs 0))
  (setq vObj (vlax-ename->vla-object obj))
  (if (or (= (casc 0 (entget obj)) #cINSERT)
          (setq isTxt (= (casc 0 (entget obj)) #cTEXT))
          (setq isMText (= (casc 0 (entget obj)) #cMTEXT)))
    (progn (setq osm  (getvar #osmode)
                 insP (if isTxt
                        (getTextInsertionPoint vObj)
                        (vlax-safearray->list (vlax-variant-value (vla-get-InsertionPoint vObj))))
                 newP insP)
           (setvar #osmode T0)
           (if (= (get_status_value flag 1) 1)
             (progn
;;;                    (if #GSTAR2016
;;;                      (progn
;;;                        (princ"\n")
;;;                        (command "_MOVE" movObs "" insP)
;;;                        (while (> (getvar "cmdactive") 0)
;;;                          (prompt "Punkt wstawienia: ")
;;;                          (command PAUSE)
;;;                        )  
;;;                        (princ"\n")
;;;                      )
;;;                      (progn
                       (prompt "\nPunkt wstawienia: ")
                       (if !command-s
                          (command-s "_MOVE" movObs "" insP PAUSE)
                          (command "_MOVE" movObs "" insP PAUSE))
;;;                      )
;;;                    )  
                    (setq newP (if isTxt
                                 (getTextInsertionPoint vObj)
                                 (vlax-safearray->list (vlax-variant-value (vla-get-InsertionPoint vObj)))))
                    (if (< (distred newP (list (* (car insP) 2.0) (* (cadr insP) 2.0) 0.0)) 5.0)
                      (progn (if isTxt
                               (msg-vla-put-TextInsertionPoint vObj insP)
                               (vla-put-InsertionPoint vObj (vlax-3d-point insP)))
                             (setq newP insP)))))
           (if (= (get_status_value flag 2) 1)
             (progn (prompt "\nKt obrotu: ")
                    (if (or isTxt isMText)
                      (setq ptb (list (+ (car newP) 10) (cadr newP) 0))
                      (if (and (arxHasAttributes obj)
                               (entnext obj))
                        (setq ptb (polar newP (vla-get-Rotation (vlax-ename->vla-object (entnext obj))) 10))
                        (setq ptb (list (car newP) (+ (cadr newP) 10) 0))))
                    (if !command-s
                      (command-s "_ROTATE" movObs "" newP "_R" newP ptb PAUSE)
                      (vl-cmdf "_ROTATE" movObs "" newP "_R" newP ptb PAUSE))
               ))
           (setvar #osmode osm)))
  (princ))      
  
(defun xjMovOrNull  (obj / vObj osm insP newP isTxt res)
  (setq res  nil
        vObj (vlax-ename->vla-object obj))
  (if (or (= (casc 0 (entget obj)) #cINSERT) (setq isTxt (= (casc 0 (entget obj)) #cTEXT)) (= (casc 0 (entget obj)) #cMTEXT))
    (progn (setq osm  (getvar #osmode)
                 insP (if isTxt
                        (getTextInsertionPoint vObj)
                        (vlax-safearray->list (vlax-variant-value (vla-get-InsertionPoint vObj))))
                 newP insP)
           (setvar #osmode T0)
           (prompt "\nPunkt wstawienia: ")
           (command "_MOVE" obj "" insP PAUSE)
           (setq newP (if isTxt
                        (getTextInsertionPoint vObj)
                        (vlax-safearray->list (vlax-variant-value (vla-get-InsertionPoint vObj)))))
           (setq res (not (< (distred newP (list (* (car insP) 2.0) (* (cadr insP) 2.0) 0.0)) 1.0)))
           (if (null res)
             (entdel obj))
           (setvar #osmode osm)))
    res) 

(defun xjCorrectScale (fn mix / res)
  (setq res T)
  (if (null (apply fn (list (dwg_skala) mix)))
    (setq res (dialog->yes_no (strcat "Obiekt nie posiada prezentacji graficznej dla biecej skali rysunku 1:" (itoa (dwg_skala)) ". Czy wstawi symbol"))))
  res)

(defun xjLaysToStrSep (kod sep / res &&)
  (setq res "")
  (foreach && (arxGetLayer kod)
    (setq res (if (= res "")
                &&
                (strcat res sep &&))))
  res) 

(defun msg_getXY  (pXY / fpx fpy spx spy dcl_id what_next _accept _getdata _check _ret w1 w2)
  (defun _check  (& pr)
    (if (and (> (strlen &) 0) (distof & 2))
      (progn (set_tile "error" "") &)
      (progn (set_tile "error" (strcat "Bd w polu " pr)) nil)))
  (defun _accept  ()
    (cond ((not (_check (get_tile "fpy") "Y")))
          ((not (_check (get_tile "fpx") "X")))
          ((not (_check (get_tile "spy") "Y")))
          ((not (_check (get_tile "spx") "X")))
          (T
           (setq _ret (list (list (atof (get_tile "fpy")) (atof (get_tile "fpx")))
                            (list (atof (get_tile "spy")) (atof (get_tile "spx")))))
           (done_dialog 1))))
  (defun _getdata  ()
    (setq fpy (rtos (caar pXY) 2 #Prec)
          fpx (rtos (cadar pXY) 2 #Prec)
          spy (rtos (caadr pXY) 2 #Prec)
          spx (rtos (cadadr pXY) 2 #Prec)))
  (setq _ret pXY)
  (if (>= (setq dcl_id (load_dialog #msg_dcl_file)) 0)
    (progn (setq what_next 2)
           (while (and (> what_next 1) (new_dialog "msg_get_wsp" dcl_id))
             (_getdata)
             (set_tile "fpx" fpx)
             (set_tile "fpy" fpy)
             (set_tile "spx" spx)
             (set_tile "spy" spy)
             (action_tile "pick" "(done_dialog 2)")
             (action_tile "accept" "(_accept)")
             (action_tile "cancel" "(progn(setq _ret nil)(done_dialog 0))")
             (setq what_next (start_dialog))
             (if (= what_next 2)
               (progn (initget 1)
                      (setq w1 (getpoint "\nPierwszy naronik: "))
                      (initget 1)
                      (setq w2  (getcorner w1 "Inny naronik: ")
                            pXY (list (list (min (car w1) (car w2)) (min (cadr w1) (cadr w2)))
                                      (list (max (car w1) (car w2)) (max (cadr w1) (cadr w2)))))
                      (_getdata))))
           (unload_dialog dcl_id)))
  _ret)

(defun WydajKod (sCode / wynik)
  (setq wynik (arxWydajKod sCode))
  (if (> (length wynik) 5)
    (list (nth 0 wynik) (nth 1 wynik) (nth 2 wynik) (nth 6 wynik) (atoi (nth 3 wynik)))
    '()))

(defun ZapiszPlineKier (obb lista / exdata &&)
  (if (setq exdata (read_exdata obb))
    (progn
      (foreach && lista
        (setq exdata (append exdata (list (list '(1000 . "PKI") (cons 1010 &&))))))
      (write_exdata obb exdata))))

(defun AddPlineKierunkowa  (pmt object more zapisz / next ents p1 p2 ret _dodaj lokPrompt &&)
  (defun _dodaj  (pa pb / ok)
    (setq ok nil)
    (if (and (not (member pa ret)) (member pb ret))
      (cond ((equal pb (last ret))
             (setq ret (append ret (list pa))
                   ok  T))
            ((equal pb (car ret))
             (setq ret (append (list pa) ret)
                   ok  T))
            (T (prompt "\nDodanie tego odcinka spowoduje niepoprawn geometri..."))))
    ok)
  (setq #markObject nil
        ret '()
        next T)
  (if more
    (progn
      (prompt (strcat "\n" pmt))
      (setq lokPrompt "Dodaj odcinek"))
    (setq lokPrompt pmt))
  (while (and next (setq ents (nentsel (strcat "\n" lokPrompt ": "))))
    (if (eq (main_item (car ents)) object)
      (progn (entsel->Odcinek ents 'p1 'p2)
             (if (> (length ret) 0)
               (progn (if (not (_dodaj p1 p2))
                        (_dodaj p2 p1)))
               (setq ret (list p1 p2)))
             (if more
               (NewMarkObj ret))
             (setq next more))
      (prompt "\nBd! Wskazany odcinek nie jest skadnikiem gwnego obiektu...")))
  (_unMarkObject)
  (if (and zapisz ret)
    (ZapiszPlineKier object ret))  
  ret)

(defun GetPlineKierunkowa  (obj / res &)
  (setq res '())
  (foreach &  (read_exdata obj)
    (if (and (= (cdar &) "PKI")
             (= (caadr &) 1010))
      (setq res (append res (list (cdr (cadr &)))))))
  res)

(defun ObjInPoly  (obj ppoly / dmin dmax wyn %%)
  (ename->vlaObj 'obj)
  (vla-GetBoundingBox obj 'dmin 'dmax)
  (setq dmin (vlax-safearray->list dmin)
        dmax (vlax-safearray->list dmax)
        wyn  T)
  (foreach %%  (list (list (car dmin) (cadr dmax)) dmax (list (car dmax) (cadr dmin)) dmin)
    (if (not (arx_inpoly %% ppoly))
      (setq wyn nil)))
  wyn)

(defun ObjCrossPoly  (obj1 ppoly1 / dmin1 dmax1 wyn1 %%)
  (ename->vlaObj 'obj1)
  (setq wyn1 (arx_inpoly (casc 10 (entget (vlax-vla-object->ename obj1))) ppoly1))
  (if (null wyn1)
    (progn (vla-GetBoundingBox obj1 'dmin1 'dmax1)
           (setq wyn1  nil
                 dmin1 (vlax-safearray->list dmin1)
                 dmax1 (vlax-safearray->list dmax1))
           (foreach %%  (list (list (car dmin1) (cadr dmax1)) dmax1 (list (car dmax1) (cadr dmin1)) dmin1)
             (if (arx_inpoly %% ppoly1)
               (setq wyn1 T)))))
  wyn1)
  
(defun _MsgHatch  (object bloks hCol hRow offs wykrEnkl / ok result pmin pmax dCol dRow pt pA bl i %% blok cLay osm zoom enk vEnks _enklawy code)
  (defun _enklawy  (/ ssb j bl dmin dmax res)
    (setq res '())
    (if (setq ssb (ssget "_CP" (polyline->wierzcholki object) (list '(0 . "INSERT,TEXT,MTEXT"))))
      (progn (setq j 0)
             (while (< j (sslength ssb))
               (setq bl (ssname ssb j)
                     j  (1+ j))
               (if (or (= (casc 0 (entget bl)) #cTEXT)
                       (= (casc 0 (entget bl)) #cMTEXT)
                       (not (in (casc 2 (entget bl)) "PIK_")))
                 (progn (vla-GetBoundingBox (vlax-ename->vla-object bl) 'dmin 'dmax)
                        (setq dmin (vlax-safearray->list dmin)
                              dmax (vlax-safearray->list dmax)
                              obk  (_createPolyline
                                     "EGBC"
                                     1
                                     (list dmin (list (car dmin) (cadr dmax)) dmax (list (car dmax) (cadr dmin)))))
                        (setq res (append res (list obk))))))))
    res)
  (setq ok T
        enk nil
        result '())
  (if (null (listp bloks))
    (setq bloks (list bloks bloks)))
  (if (null offs)
    (setq offs (/ hCol 2.0)))
  (foreach %%  bloks
    (if (not (definiuj_blok %% T))
      (setq ok nil)))
  (if ok
    (progn (setq zoom (get_currZoom)
                 code (object->getCode object))
           (polyline->zoom object)
           (if !command-s
             (command-s "_.UNDO" "_group")
             (vl-cmdf "_.UNDO" "_group"))
           (if wykrEnkl
             (progn (setq vEnks (_enklawy)
                          enk   (kontur->enklawa object "EGB,OTB"))))
           (setq cLay (getvar "CLAYER")
                 osm (getvar #osmode))
           (SetLay (casc 8 (entget object)))
           (setvar #osmode 0)
           (vla-GetBoundingBox (vlax-ename->vla-object object) 'pmin 'pmax)
           (setq pmin (vlax-safearray->list pmin)
                 pmax (vlax-safearray->list pmax)
                 dCol 0.0
                 dRow 0.0
                 i    0)
           (while (< dRow (abs (- (cadr pmax) (cadr pmin))))
             (if (= (msg_mod i 2) 0)
               (setq pA (list (car pmin) (- (cadr pmax) dRow)))
               (setq pA (list (- (car pmin) offs) (- (cadr pmax) dRow))))
             (while (< dCol (abs (- (+ (car pmax) offs) (car pmin))))
               (setq pt   (polar pA 0 dCol)
                     dCol (+ dCol hCol)
                     blok (if (= blok (car bloks))
                            (cadr bloks)
                            (car bloks)))
               (if (arx_inpoly pt object)
                 (progn
               (setq bl (_createBlock blok pt 0 nil))
               (SetColorByCode code bl)
               (if (ObjInPoly bl object)
                 (progn (setq ok T)
                        (if enk
                          (foreach %%  (append enk vEnks)
                            (if (ObjCrossPoly bl %%)
                              (progn (setq ok nil)))))
                        (if ok
                          (setq result (append result (list bl)))
                          (entdel bl)))
                 (entdel bl))
               ))
             )
             (setq i    (1+ i)
                   dRow (+ dRow hRow)
                   dCol 0.0))
           (if vEnks
             (foreach %% vEnks (entdel %%)))
           (if (null result)
             (setq result (list (_createBlock blok (centroid object) 0 nil))))
           (if result
             (_makeGroup result "HTH"))
           (Setlay cLay)
           (arxZoomWindow (car zoom) (cadr zoom))
           (setvar #osmode osm)
           (if !command-s
             (command-s "_.UNDO" "_end")
             (vl-cmdf "_.UNDO" "_end"))))
  result)

(defun HasWipeout  (bName / bl res)
  (setq res nil)
  (if (and (setq bl (tblsearch #cBLOCK bName)) (setq bl (casc -2 bl)))
    (progn (setq res (= (casc 0 (entget bl)) #cWIPEOUT))
           (while (and (null res) (setq bl (entnext bl))) (setq res (= (casc 0 (entget bl)) #cWIPEOUT)))))
  res)

(defun WipeOutFrames  (ZeroOrOne / data)
  (if (getvar #wipeoutfr)
    (setvar #wipeoutfr ZeroOrOne)
    (if !command-s
      (command-s "_WIPEOUT" "_F" (if (= ZeroOrOne 0) "_OFF" "_ON"))
      (command "_WIPEOUT" "_F" (if (= ZeroOrOne 0) "_OFF" "_ON")))
    ))

(defun ModOrder (obj / ln)
  (if (and (= (casc 0 (entget obj)) #cINSERT) (HasWipeout (casc 2 (entget obj))))
    (progn (WipeOutFrames 1)
           (arxDraworder obj #ToFront)
           (WipeOutFrames 0)
           (if (setq lnk (GetLink obj "RZG"))
             (arxDraworder lnk #ToFront)))))

(defun AnyObjK1  (%kodL% / kodC res)
  (setq res  nil
        kodC (kod_cyf %kodL%))
  (if (> (car kodC) 0)
    (setq kodC (car kodC)
          res  (or (and (> kodC 0) (< kodC 759)) (and (> kodC 800) (< kodC 997)) (= kodC 2201))))
  res)

(defun _MsgBurst  (ename / ms Atts vA sAtt vTxt & sa isMulti)
  (ename->vlaObj 'ename)
  (if (= (vla-get-ObjectName ename) "AcDbBlockReference")
    (progn (if (= (casc 67 (entget (vlax-vla-object->ename ename))) 1)
             (setq ms (vla-get-PaperSpace #acadDoc))
             (setq ms #ModelS))
           (if (arxHasAttributes (vlax-vla-object->ename ename))
             (setq Atts (vla-GetAttributes ename))
             (setq Atts nil))
           (if Atts
             (progn
               (foreach vA  (vlax-safearray->list (vlax-variant-value Atts))
                 (setq sAtt (vla-get-TextString vA))
                 (if #Toolkit
                   (setq isMulti (vl-string-position (ascii "\n") sAtt))
                   (setq isMulti (and (vlax-property-available-p vA 'MTextAttribute) (= (vla-get-MTextAttribute vA) :vlax-true))))
                 (if isMulti
                   (progn (if #Toolkit
                            (progn (setq vTxt (vla-AddMText ms (vla-get-InsertionPoint vA) 0 sAtt))
                                   (vlax-put-property vTxt 'AttachmentPoint 5))
                            (progn (setq vTxt (vla-AddMText ms (vla-get-InsertionPoint vA) (vla-get-MTextBoundaryWidth vA) sAtt))
                                   (vlax-put-property vTxt 'AttachmentPoint (vlax-get-property vA 'MTextDrawingDirection))))
                          (foreach &  (list 'Height 'Layer 'Linetype 'LinetypeScale 'Lineweight 'Rotation 'StyleName)
                            (vlax-put-property vTxt & (vlax-get-property vA &)))
                          (if (/= (vla-get-Alignment vA) acAlignmentLeft)
                            (vlax-put-property vTxt 'InsertionPoint (vlax-get-property vA 'TextAlignmentPoint))))
                   (progn (setq vTxt (vla-AddText ms sAtt (vla-get-InsertionPoint vA) (vla-get-Height vA)))
                          (foreach &  (list 'Alignment 'Backward 'Layer 'Linetype 'LinetypeScale 'Lineweight 'ObliqueAngle 'Rotation 'ScaleFactor 'StyleName 'Thickness 'UpsideDown)
                            (vlax-put-property vTxt & (vlax-get-property vA &)))
                          (msg-vla-put-TextInsertionPoint vTxt (getTextInsertionPoint vA)))))))
           (vla-Explode ename)
           (if Atts
             (if (setq sa (ssget "_X" (list (cons 67 (casc 67 (entget (vlax-vla-object->ename ename)))) (cons 0 "ATTDEF"))))
               (if !command-s
                 (command-s "_ERASE" sa "")
                 (command "_ERASE" sa ""))))
           (if (setq sa (ssget "_X" (list (cons 67 (casc 67 (entget (vlax-vla-object->ename ename)))) (cons 0 "HATCH"))))
             (arxDraworder sa #ToBack))
           (if ename
             (vla-delete ename)))))

(defun TransPkt  (pkr pIdx wIdx / fP fW exe fle linia ww)
  (setq pIdx (if (> pIdx 5)
               (- pIdx 2)
               (- pIdx 1))
        wIdx (if (> wIdx 5)
               (- wIdx 2)
               (- wIdx 1))
        fP   (vl-filename-mktemp "" "" ".txt")
        fW   (vl-filename-mktemp "" "" ".txt"))
  (if (and (setq exe (findfile "_XJLib.exe")) (setq fle (open fP "w")))
    (progn (write-line
             (strcat "0 AcDbBlockReference 0 "
                     (rtos (car pkr) 2 6)
                     " "
                     (rtos (cadr pkr) 2 6)
                     " "
                     (rtos (caddr pkr) 2 6))
             fle)
           (close fle)
           (if (ExecAndWait (strcat "\"" exe "\" #zyc \"" fP "\" \"" fW "\" 0 " (itoa pIdx) " " (itoa wIdx) " 1"))
             (progn (if (setq fle (open fW "r"))
                      (progn (setq linia (read-line fle))
                             (close fle)
                             (setq ww (_podziel linia))
                             (if (= (length ww) 6)
                               (setq pkr (list (atof (nth 3 ww)) (atof (nth 4 ww)) (atof (nth 5 ww)))))))))))
  (vl-file-delete fP)
  (vl-file-delete fW)
  pkr)

(defun _FloatToStrF (var / res)
  (setq res (vl-string-right-trim "0" (rtos var 2 6)))
  (if (= (vl-string-position (ascii ".") res) (1- (strlen res)))
    (setq res (strcat res "0")))
  res)
  
(defun SelectModelXByMsg  (lista / newent)
  (setq newent (list (cons -3 (list (list #msg_app))) (cons 67 0)))
  (if (/= lista nil)
    (setq newent (append newent lista)))
  (ssget "_X" newent))      

(defun dwg_DataModWer  (/ cdate ss)
  (setq cdate (rtos (getvar "CDATE") 2 6)
        ss    (atoi (substr cdate 14 2)))
  (if (>= ss 60)
    (setq ss (- ss 60)))
  (strcat (substr cdate 1 4)
          "-"
          (substr cdate 5 2)
          "-"
          (substr cdate 7 2)
          "T"
          (substr cdate 10 2)
          ":"
          (substr cdate 12 2)
          ":"
          (UzupStr (itoa ss) "0" 2)))

