;;;;; Bedzie wC++

(defun opis_atrybutu (s)
  (list 0 "" ""))

(defun arxZrodlo (s)
  1)

(defun msg_init (/ & fName)
  (if (or (null initCpp) (null dwg_precWSP) (null dwg_precWSU))
    (progn
      (princ "\n*** Bd! Nie zaadowane pliki RX ***")
      (princ "\n*** Program Mapa_SG nie zosta uruchomiony! ***")
      (exit)))
  (vl-load-com)
 
  (setq #tile_msg2000 "Mapa_SG V17"
        #acadApp (vlax-get-acad-object)
        #AcadVer (atof (getvar "ACADVER"))
        #Brics (= (strcase (getvar "PRODUCT")) "BRICSCAD")
        #GSTAR8 (= (strcase (getvar "PRODUCT")) "GSTARCAD")
        #GSTAR2016 (and (getvar "GCADVER") (or (vl-string-search "15" (getvar "GCADVER"))
                                               (vl-string-search "16" (getvar "GCADVER"))
                                               (vl-string-search "17" (getvar "GCADVER"))
                                               (vl-string-search "18" (getvar "GCADVER"))
                                               (vl-string-search "19" (getvar "GCADVER"))
                                               (vl-string-search "20" (getvar "GCADVER"))
                                               (vl-string-search "21" (getvar "GCADVER"))
                                               (vl-string-search "22" (getvar "GCADVER"))
                                               (vl-string-search "23" (getvar "GCADVER"))
                                               (vl-string-search "24" (getvar "GCADVER"))
                                               (vl-string-search "25" (getvar "GCADVER"))))
        !command-s (and  command-s (null #Brics) (>= #AcadVer 20.0))
  )
;;;  (if (null #GSTAR8)
;;;    (if (and (getvar "GCADVER") (or (vl-string-search "23" (getvar "GCADVER"))
;;;                                    (vl-string-search "24" (getvar "GCADVER"))
;;;                                    (vl-string-search "25" (getvar "GCADVER"))))
;;;      (setq #x64 33))
;;;    (setq  #x64 (vl-string-search "(x64)" (getvar "PLATFORM"))))

  (setq   
    #acadDoc (vla-get-Activedocument #acadApp)
    #ModelS  (vla-get-modelSpace #acadDoc)
    fName (vla-get-fullname #acadApp)
    #ExeName (if #Brics
               "bricscad.exe"
               (strcat (vl-filename-base fName) (vl-filename-extension fName)))
    #LTVer (and (null #Brics) (null #GSTAR) (null #GSTAR8) (null #ZWCAD2017) (/= (strcase #ExeName) "ACAD.EXE"))
    #PLKVer (= (vla-get-LocaleID #acadApp) (if #ZWCAD 21 1045))
    #msg_app "MSG40"    
    #Toolkit (or (= (substr (vla-get-Caption #acadApp) 1 10) "!SlingShot")
                 (= (substr (vla-get-Caption #acadApp) 1 15) "CADSTA Elements"))
  )
  (if #GSTAR
    (setq #icadver (atof (getvar "ICADVER"))))
 
  (if (findfile #ExeName)
    (setq #AcPath (strcat (vl-filename-directory (findfile #ExeName)) "\\"))
    (setq #AcPath ""))
  (if #Brics
    (setq fName (findfile "XCBMsg.Brx"))
    (if (or #GSTAR #GSTAR8 #GSTAR2016)
      (setq fName (findfile "XCGMsg.grx"))
      (if #ZWCAD2017
        (setq fName (findfile "XCMsg.zrx"))
        (setq fName (findfile "CMsg.arx")))))
  (if fName
    (setq #MsgPath (strcat (vl-filename-directory fName) "\\"))
    (setq #MsgPath ""))
  (if (or #Toolkit #GSTAR)
    (setq acByBlock 0
          acRed 1
          acYellow 2
          acGreen 3
          acCyan 4
          acBlue 5
          acMagenta 6
          acWhite 7
          acByLayer 256

          acLnWt000 0
          acLnWt005 5
          acLnWt009 9
          acLnWt013 13
          acLnWt015 15
          acLnWt018 18
          acLnWt020 20
  	  acLnWt025 25
  	  acLnWt030 30
  	  acLnWt035 35
  	  acLnWt040 40
  	  acLnWt050 50
  	  acLnWt053 53
  	  acLnWt060 60
  	  acLnWt070 70
  	  acLnWt080 80
  	  acLnWt090 90
  	  acLnWt100 100
  	  acLnWt106 106
  	  acLnWt120 120
  	  acLnWt140 140
  	  acLnWt158 158
  	  acLnWt200 200
  	  acLnWt211 211
       	  acLnWtByLayer -1
          acLnWtByLwDefault -3

          acAlignmentCenter 1
          acAlignmentTopCenter 7
          acShadePlotHidden 2
          acExtendNone 0
          acExtendThisEntity 1
          acExtendBoth 3))
  (setq 
    T0 0
    T1 1
    T4 4
    T6 6
    T8 8
    T12 12
    T32	32
    T40 40
    T64	64
    T72	72
    T512 512
    T520 520
    #pi2 (/ pi 2.0)
    #pi4 (/ pi 4.0)
    &Lpkt '("PIK_")
    #c_IN "IN"
    #c_BU "BU"
    #c_GR "GR"
    #c_KL "KL"
    #c_OS "OS"
    #c_UL "UL"
    #c_UZ "UZ"
    #c_ZA "ZA"
    #cBUD "BUD"
    #useri1       "USERI1"
    #useri2       "USERI2"
    #useri3       "USERI3"
    #useri4       "USERI4"
    #userr5       "USERR5"
    #osmode       "OSMODE"
    #clayer       "CLAYER"
    #dwgpref      "DWGPREFIX"
    #dwgname      "DWGNAME"
    #limmin       "LIMMIN"
    #limmax       "LIMMAX"
    #viewsize     "VIEWSIZE"
    #cmdecho      "CMDECHO"
    #tilemode     "TILEMODE"
    #snapbase     "SNAPBASE"
    #wipeoutfr    "WIPEOUTFRAME"
    #cKod         "KOD"
    #cLayArchiwum "ARCHIWALNA"
    #lst_pkt (list #c_IN #c_BU #c_GR #c_KL #c_OS #c_UL #c_UZ #c_ZA)
    #lst_skal '(500 1000 2000 5000 10000)
    #typ_p #c_IN
    #max_nr 15
    #precWSP (dwg_precWSP)
    #precWSU (dwg_precWSU)
    #toler 0.02
    #obrot 100.0
    #metoda "L"
    #ltMetBud #metoda
    #ltMetKom #metoda
    #WstTxt "1"
    #wXY (list (getvar #limmin) (getvar #limmax))
    #KartaM ""
    #GetAtt nil
    #cStrCat strcat
    #scr-pt (list (fix -1) (fix -1))
    #lst_zrd (msg_getcfg "Zrodlo" "0")
    #UkladyWsp '("Lokalny" "1965 strefa 1" "1965 strefa 2" "1965 strefa 3" "1965 strefa 4" "1965 strefa 5" "Szczecin" "2000 pas 5" "2000 pas 6" "2000 pas 7" "2000 pas 8" "Warszawa" "Krakw")
    #ltaGESZRD '("O - Pomiar na osnow i obliczenia" "A - Pomiar wykrywaczem przewodw" "B - Dane branowe" "D - Digitalizacja mapy i wektoryzacja rastra"
                 "F - Fotogrametria" "G - GPS bez powizania z osnow" "I - Inne" "M - Pomiar w oparciu o elementy mapy" "N - Niepoprawne" "X - Nieokrelone")
    #ltaBDZZRD '("O - Pomiar na osnow i obliczenia" "D - Digitalizacja mapy" "F - Fotogrametria" "G - GPS bez powizania z osnow"
                 "X - Nieokrelone - brak danych" "N - Niepoprawne" "M - Pomiar w oparciu o elementy mapy" "I - Inne")
    #ltaSieci '("b" "c" "e" "g" "k" "n" "t" "w" "z" "i")
    ;#ltaSieci2021 '("w" "k" "e" "g" "c" "t" "s" "x")
    #listaSieciK1 '("w" "k" "g" "c" "e" "t" "b" "x" "n" "p" "a" "v" "m" "i" "z" "j" "q")
    #ltaPWSiec (append #ltaSieci '("m"))
    #wspolcz_getZoomPolyline 0.15
    #cPOLYLINE "POLYLINE"
    #cLWPOLYLINE "LWPOLYLINE"
    #cVERTEX "VERTEX"
    #cARC "ARC"
    #cLINE "LINE"
    #cPOINT "POINT"
    #cMLINE "MLINE"
    #cCIRCLE "CIRCLE"
    #cSPLINE "SPLINE"
    #cINSERT "INSERT"
    #cTEXT "TEXT"
    #cATTRIB "ATTRIB"
    #c3DFACE "3DFACE"
    #cHATCH "HATCH"
    #cVIEWPORT "VIEWPORT"
    #cLINK "LINK"
    #cITEM "ITEM"
    #cBLOCK "BLOCK"
    #cATTDEF "ATTDEF"
    #cELLIPSE "ELLIPSE"
    #cMTEXT "MTEXT"
    #cSEQEND "SEQEND"
    #cWIPEOUT "WIPEOUT"
    #cons1000LINK (cons 1000 #cLINK)
    #c_BYLAYER "_BYLAYER"
    #cContinuous "Continuous"
    #cNR_ADRESOWY "NR_ADRESOWY"

    #cSTANDARD "STANDARD"
    #c_INSERT "_.INSERT"
    #krzyz_rozmiar 5.0
    #par_polig 254
    #AttribOnly nil
    #glob_elist nil  ;;; Do likwidacji
    #glob_lstPoints nil
    #is_localUPWSiersza nil  ;;;; Siersza ONLY
    #lista_warstw
     '("PPINP" "PPINO" "PPGRP" "PPGRO" "PPBUP" "PPBUO" "PPULP" "PPULO"
       "PPKLP" "PPKLO" "PPUZP" "PPUZO" "PPOSP" "PPOSO" "PPZAP" "PPZAO"
       "PP$$O"
       ) 
    #AllPikStr "PIK_??"
    #ConsAllPikStr (cons 2 #AllPikStr)
    #msg_blok_path (strcat (read_msgini "Common" #MsgPath) "\\bloki\\")
    #msg_arkusze_path (strcat (read_msgini "Common" #MsgPath) "\\arkusze\\")
    #msg_plik_tmp
     (strcat #MsgPath "tmp.msg")
    #msg_dcl_tmp
     (strcat #MsgPath "tmp.dcl")
    #msg_base_dcl
     (strcat #MsgPath "msg.mdc")
    #aktywny_dialog
     (= (msg_getcfg "dialog" 1) 1)
   ;; #msg_help_file (strcat #MsgPath "k1'98.hlp")
    #msg_dcl_file "msg17.dcl"
;;;    transformacja
    #filepath       (vl-filename-directory (getvar #dwgpref))
    #filename       (vl-filename-base (getvar #dwgname))
    #glob_ltscale   (getvar "LTSCALE")
    #kolor_krzyza  -1
    #magnification 100
    #opisSelSet    0
    #ErrStr "\nNie speniono warunkw wykonania zadania..."
    #BudynekNaDzialce ""	  
    
    #markObject      nil
    #markColor       (GetKolorWyroznienia1)
    #markLineweight  acLnWt050   
    #CzekajStr       "Czeka..."
    #ErrorLayer      "Bdy"
    
    ;;;  XJ
    
    #isNapow nil 
    #figuraMet nil 
    SK_SEP "|" 
    #cObk2 "obiekt2"
    #cObk "obiekt"
    #cMULTI "MULTI"
     
    #selErase T ;; XT
    #wipeOffset 0.02 ; XT
    #defZRE nil
    #defBPP nil
    #defSTB nil
    #defGRT "EGPG_a"
    #msgKlucz "HKEY_LOCAL_MACHINE\\SOFTWARE\\Mapsoft\\msg17"

    #cPLINEALL (strcat #cPOLYLINE "," #cLWPOLYLINE)
    #cPLINEMLINE (strcat #cPLINEALL "," #cMLINE)

    ;;; 01.07.2004
    #IloscXRecord 5
    #multiInsert nil
    #msg_oknoZrodlo 0
    #vbaEntityName nil
    #osToru nil 
    #zoomTo T 
    #FnCancelled (if #PLKVer
		   "Funkcja anulowana"
		   "Function cancelled")
    ;;; 22.08.2016 SZKIC
    #def_listaStab "|k/p|k/p..|Rm|trzp|k|palik" 
    ;;; 18.02.2018 Draworder
    #ToBack 0
    #ToFront 1
    #voidList (list "inapplicable" "missing" "templat" "unknown" "withheld")
    #MTextOrText T
    #wykrEnklawy T
  )
 
  (foreach &  '(("TILEMODE" 1) ("CMDECHO" 0) ("PSLTSCALE" 0) ("ATTREQ" 1) ("COORDS" 1)
	       ("EXPERT" 1) ("LISPINIT" 0) ("PSLTSCALE" 1) ("WMFBKGND" 0)
              )
    (setvar (car &) (cadr &))
  )
  (resourcestring)

  (setq #ltaZRD '())
  (foreach & #ltaBDZZRD
    (setq #ltaZRD (append #ltaZRD (list (substr & 1 1))))
  )

  (if (and (null #GSTAR) (null #LTVer))
    (if !command-s
      (command-s "_.UNDEFINE" "ID")
      (vl-cmdf "_.UNDEFINE" "ID")))

  (if (and initCpp
           (arxMsgCorrect))
    (progn
      (if (null #GSTAR8)
        (initCpp))
      (if (or #GSTAR8 (null (tblsearch "APPID" #msg_app)))
         (regapp #msg_app))

      (if #lst_zrd
        (displayZrodlo #lst_zrd (dwg_KRG)))

      (MainW)
      (Init::K1)

      (if (null arxZoomWindow)
        (defun arxZoomWindow (p1 p2)
           (vla-ZoomWindow #acadApp (vlax-3d-point p1) (vlax-3d-point p2))))
   
      (if (null arxZoomCenter)
        (defun arxZoomCenter (p1 mag)
          (vla-ZoomCenter #acadApp (vlax-3d-point p1) mag)))

      (if (null arxZoomExtents)
        (defun arxZoomExtents ()
          (vla-ZoomExtents #acadApp)))

      (_Profil)

      (poprawki)
     )
   )
)

(defun _RedefMenu  (redef / mGroups & item)
  (if redef
    (progn (setq mGroups (vlax-get-property #acadApp 'MenuGroups))
           (foreach &  '("MSGV16Rysuj" "MSGV16Zmiana" "MSGV16Warstwy" "MSGV16Punkty" "MSGV16Uzytkowe" "MSGV16Inne")
             (if (= (menugroup &) &)
               (progn (setq item (vla-Item mGroups &)) (vla-unload item))))
           (if (= redef 1)
             (foreach &  '("MSGV17_RYSUJ" "MSGV17_ZMIANA" "MSGV17_WARSTWY" "MSGV17_PUNKTY" "MSGV17_UZYTKOWE" "MSGV17_INNE")
               (if (= (menugroup &) &)
                 (progn (setq item (vla-Item mGroups &)) (vla-unload item)))))))
  (_placeMenu "MsgV17_1" "MSGV17_Rysuj")
  (_placeMenu "MsgV17_2" "MSGV17_Zmiana")
  (_placeMenu "MsgV17_3" "MSGV17_Warstwy")
  (_placeMenu "MsgV17_4" "MSGV17_Punkty")
  (_placeMenu "MsgV17_5" "MSGV17_Uzytkowe")
  (_placeMenu "MsgV17_6" "MSGV17_Inne"))


(defun C:REDEFMENU () (_redefMenu 1))

(defun _Profil  (/ currVer mProf PrefProf names)
  (setq PrefProf (vla-get-Profiles (vla-get-Preferences #acadApp))
        currVer  (vla-get-ActiveProfile PrefProf)
        mProf    #tile_msg2000)
  (if (= currVer mProf)
    (progn (_RedefMenu nil))
    (progn (vla-GetAllProfileNames PrefProf 'names)
           (setq names (vlax-safearray->list names))
           (if (null (member mProf names))
             (vla-CopyProfile PrefProf (car names) mProf))
           (vla-GetAllProfileNames PrefProf 'names)
           (setq names (vlax-safearray->list names))
           (if (member mProf names)
             (progn (vla-put-ActiveProfile PrefProf mProf) (_RedefMenu T))))))  

(defun msg_myerr  (s)
  (if (and (> (strlen s) 0) (/= s #FnCancelled))
    (princ (strcat "\n*" s "*")))
  (if #fle
    (msg_close_fle))
  (if #is_pss
    (pss_done))
  (_unMarkObject)
  (WymazElementy #sslin)
  (setq #sslin nil)
  (setq #is_uzbrojenie nil
        *error* msg_olderr)
  (lovar)
  (princ))

(defun msg_savar  (var)
  (setq #MSG_STAN '())
  (repeat (length var)
    (setq #MSG_STAN (append #MSG_STAN (list (list (car var) (getvar (car var))))))
    (setq var (cdr var))))

(defun lovar  (/ a ss %%)
  (if (> (length #MSG_STAN) 0)
    (progn (repeat (length #MSG_STAN)
             (setq a (caar #MSG_STAN))
             (cond ((= a #snapbase)  (setvar #snapbase (list (car (cadar #MSG_STAN)) (cadr (cadar #MSG_STAN)))))
                   ((= a #clayer) (setLay (cadar #MSG_STAN)))
                   ((= a "CELTYPE")
                    (if !command-s
                      (command-s "_.-LINETYPE" "_S" (cadar #MSG_STAN) "")
                      (vl-cmdf "_.-LINETYPE" "_S" (cadar #MSG_STAN) "")))
                   (T (setvar a (cadar #MSG_STAN))))
             (setq #MSG_STAN (cdr #MSG_STAN)))
           (setq #MSG_STAN nil)
           (if !command-s
             (progn
               (command-s "_.UCS" "_W")
               (command-s "_.UNDO" "_end")
             )
             (progn
               (vl-cmdf "_.UCS" "_W")
               (vl-cmdf "_.UNDO" "_end")))
           (setq #MTextOrText T
                 ss nil
                 #sslin nil
                 #plinAsCircle nil
                 #isNapow nil 
                 #isBlokSiec nil 
                 #atrybuty nil 
                 *error* msg_olderr)))
  (princ))

(defun GetC  (p r)
  (ssget "_C" (list (- (car p) r) (- (cadr p) r)) (list (+ (car p) r) (+ (cadr p) r))))

(defun GetCEn  (p r filter lay_f / ss)
  (setq r (* r #wsp))
  (if lay_f
    (setq filter (append filter (list lay_f))))
  (setq ss (ssget "_C" (list (- (car p) r) (- (cadr p) r)) (list (+ (car p) r) (+ (cadr p) r)) filter))
  ss)

(defun Tryb  (os)
  (if initCpp
    (progn (setvarif #cmdecho 0)
           (setvarif "TILEMODE" 1)
           (if !command-s
             (command-s "_.UNDO" "_group")
             (vl-cmdf "_.UNDO" "_group"))
           (WipeOutFrames 0)
           (setq msg_olderr  *error*
                 *error*     msg_myerr
                 #wsp        (/ (dwg_skala) 1000.0)
                 #prec       (getvar "LUPREC")
                 #pInsert    nil
                 #markObject nil
                 #is_pss     nil
                 #sslin      nil
                 #osToru nil)
           (msg_savar (list #clayer #osmode "BLIPMODE" "ATTDIA" "REGENMODE" "SNAPBASE" "SNAPMODE" "SNAPANG" "SNAPUNIT" "CECOLOR" "CELTYPE" "FILEDIA" "CELWEIGHT" "INSUNITS" "DIMZIN" "OSMODE" "ORTHOMODE"))
           (if !command-s
             (command-s "_.-LINETYPE" "_S" "BYLAYER" "")
             (vl-cmdf "_.-LINETYPE" "_S" "BYLAYER" ""))
           (setvarIf "CELWEIGHT" -1)
           (setvarIf "PLINETYPE" 0)
           (setvarIf "INSUNITS" 0)
           (setvarIf "DIMZIN" 0)
           (cond ((dwg_lokalizacja)
                  (if (eq (dwg_LokCfg) 1)
                    (setq os (getvar #osmode))))
                 (T (setq os 0)))
           (TrybCpp os)
           (setq #acadApp (vlax-get-acad-object)
                 #acadDoc (vla-get-Activedocument #acadApp)
                 #ModelS  (vla-get-modelSpace #acadDoc))
           T)
    nil))

(defun msg_getreal  (prom default precision / a)
  (setq a (getreal (strcat "\n"
                           prom
                           (if default
                             (strcat " [" (rtos default 2 precision) "]")
                             "")
                           ": ")))
  (cond ((null a)
         (if default
           default
           0.0))
        (T a)))

(defun _get11  (p)
  (setq #cross nil)
  (if (equal (casc 0 (entget p)) #cLINE)
    (casc 11 (entget p))
    (if (equal (casc 0 (entget (entnext p))) #cSEQEND)
      (progn (setq #cross T) (casc 10 (entget (entnext (casc -2 (entget (entnext p)))))))
      (casc 10 (entget (entnext p))))))

(defun entsel->Odcinek  (object &p10 &p11 / point e wierz listaW i & its)
  (setq point  (cadr object)
        object (car object)
        res 0
        e      (entget object))
  (cond ((eq (casc 0 e) #cLINE) (set &p10 (casc 10 e)) (set &p11 (casc 11 e)))
        ((eq (casc 0 e) #cVERTEX) (set &p10 (casc 10 e)) (set &p11 (_get11 object)))
        ((in (casc 0 e) (list #cPOLYLINE #cLWPOLYLINE #cMLINE))
         (setq wierz  (polyline->wierzcholki object)
               listaW '()
               i 0)
         (if (checkClosedPolyline object)
           (setq wierz (append wierz (list (car wierz)))))
         (while (< i (- (length wierz) 1))
           (setq its (or (< (distred point (rzut (nth i wierz) (nth (+ i 1) wierz) point)) 0.01)
                         (inters point (rzut (nth i wierz) (nth (+ i 1) wierz) point) (nth i wierz) (nth (+ i 1) wierz) T)))
           (if its
             (setq listaW (append listaW (list i))))
           (setq i (1+ i)))
         (setq dd 1000000.0)
         (if listaW
           (foreach &  listaW
             (if (< (distred point (rzut (nth & wierz) (nth (+ & 1) wierz) point)) dd)
               (progn (setq dd (distred point (rzut (nth & wierz) (nth (+ & 1) wierz) point)))
                      (set &p10 (nth & wierz))
                      (set &p11 (nth (+ & 1) wierz)))))))
        (T (set &p10 nil) (set &p11 nil))))

(defun getRP  (pa pb / a p ret w1 w2)
  (initget #Przedluz)
  (setq pa (_2D pa)
        pb (_2D pb)
        a  (getreal (strcat "\nOkrel odlego lub [" #Przedluz "/" #Odleg "] <" (rtos (distance pa pb) 2 #Prec) ">: ")))
  (cond ((= a #Przedluz)
         (while (or (null (setq p (nentsel #WskazOdcinek)))
                    (not (in (casc 0 (entget (car p))) (list #cLINE #cVERTEX #cPOLYLINE #cLWPOLYLINE)))))
         (entsel->Odcinek p 'w1 'w2)
         (setq ret (inters pa pb w1 w2 nil)))
        (T
         (if (null a)
           (setq a (distance pa pb)))
         (setq ret (polar pa (angle pa pb) a))))
  ret)

(defun okno_minmax  (okno / pa pb)
  (setq pa (car okno)
        pb (cadr okno))
  (list (list (min (car pa) (car pb)) (min (cadr pa) (cadr pb)))
        (list (max (car pa) (car pb)) (max (cadr pa) (cadr pb)))))

(defun vertex_minmax  (vertex / lx ly)
  (foreach &  vertex
    (setq lx (append lx (list (cadr &)))
          ly (append ly (list (car &)))))
  (list (list (apply 'min ly) (apply 'min lx)) (list (apply 'max ly) (apply 'max lx))))

(defun ok_okno  (pkt pa pb / okno)
  (setq okno (okno_minmax (list pa pb))
        pa   (car okno)
        pb   (cadr okno))
  (and (>= (car pkt) (car pa))
       (>= (cadr pkt) (cadr pa))
       (<= (car pkt) (car pb))
       (<= (cadr pkt) (cadr pb))))

(defun EqAng  (a1 a2)
  (equal (/ (fix (+ (* (OkAng a1) 10000.0) 0.5)) 10000.0)
         (/ (fix (+ (* (OkAng a2) 10000.0) 0.5)) 10000.0)))

(defun Strona (a b c) (EqAng (angle a b) (- (angle (Rzut a b c) c) (/ pi 2))))

(defun _chInsert  (ePkt typ ncode / alay st tr p e w lay _nr aa hh oitem item exdata color)
  (setq color    (vla-get-Color (vlax-ename->vla-object ePkt))
        alay     (strcat "PP" typ "P")
        tr       (getvar #osmode)
        lay      (getvar #clayer)
        p        (casc 10 (entget ePkt))
        w        (casc 10 (entget (entnext ePkt)))
        _nr      (casc 1 (entget (entnext ePkt)))
        aa       (casc 50 (entget (entnext ePkt)))
        hh       (casc 40 (entget (entnext ePkt))))
  (if (= color acByLayer)
    (setq color (vla-get-color (vlax->Layer (vla-get-Layer (vlax-ename->vla-object (entnext ePkt)))))))
  (if (tblsearch "LAYER" alay)
    (progn (setq st     (minusp (casc 62 (tblsearch "LAYER" alay)))
                 exdata (read_exdata ePkt))
           (setvar #osmode 0)
           (setLay alay)
           (setq p           (InsertPoint p _nr typ ncode nil)
                 EnPkt       p
                 #enPkt_undo p
                 e           (entget (entnext p))
                 e           (subst (cons 10 w) (assoc 10 e) e)
                 e           (subst (cons 50 aa) (assoc 50 e) e)
                 e           (subst (cons 40 hh) (assoc 40 e) e)
                 item        (list _nr p))
           (entmod e)
           (entupd p)
           (if exdata
             (write_exdata p exdata))
           (change_lstPoints ePkt p)
           (entdel ePkt)
           (setLay lay)
           (if st
             (vla-put-LayerOn (vlax->Layer alay) :vlax-false))
           (if (dwg_ZmienKolor)
             (vla-put-Color (vlax-ename->vla-object p) color))
           (setvar #osmode tr))
    (progn (prompt (strcat "\nNie odnaleziona warstwa [" alay "] w funkcji _chInsert...\n"))
           (setq p ePkt)))
  p)

(defun _drawObjectErr  (var)
  (WymazElementy #sstxt)
  (setq #sstxt nil)
  (msg_myerr var))

(defun DefaultTyp  (kod / res)
  (if (and kod (setq res (WydajKod kod)))
    (progn (if (= (nth 1 res) "")
             (prompt (strcat "\nUwaga! Nie zdefiniowany typ dla kodu [" kod "]...")))
           (nth 1 res))
    #c_IN))

(defun changePointType  (newKod / newTyp oldKod oldTyp action np EP)
  (setq #PkrUndo (list nil nil))
  (if (and EnPkt (entget EnPkt) newKod (/= newKod ""))
    (progn (setq action     T
                 newTyp     (DefaultTyp newKod)
                 oldTyp     (substr (casc 2 (entget EnPkt)) 5 2)
                 oldKod     (casc 1 (entget (entnext (entnext EnPkt))))
                 #code_undo oldKod
                 #typ_undo  oldTyp
                 #PkrUndo   (list EnPkt nil))
           (cond ((and (= newKod "SUPS") (/= (vl-string-Trim " " oldKod) ""))
                  (setq action nil))
                 ((and (< (car (kod_cyf oldKod)) 1111) (> (car (kod_cyf newKod)) 1110) (< (car (kod_cyf newKod)) 2000))
                  (setq action T))
                 ((in newKod '("WSU" "WSP")) (setq action nil))
                 ((in oldTyp (list #c_GR #c_OS))
                  (if (wcmatch newKod "EGPG,GRZG,GRZP,GRT,GRO,GRP")
                    (setq action T)
                    (setq action nil)))
                 ((= oldTyp #c_BU) (setq action (= newTyp #c_GR))))
           (if action
             (progn (if (not (dwg_ZmienKod))
                      (setq newKod oldKod))
                    (setq EP          EnPkt
                          np          (_chInsert EnPkt newTyp newKod)
                          #enPkt_undo np
                          #PkrUndo    (list EP np)))))))

(defun GetPointZ  (prom przyr alter prev code / p oldtr l e pr altpr altin Ok en w ex __alt _isnr _ret)
  (setq altpr ""
        altin ""
        EnPkt nil
        oldtr (getvar #osmode)
        __alt alter
        ex    T)
  (if alter
    (repeat (length alter)
      (setq altpr (strcat altpr "/" (car alter))
            altin (strcat altin " " (car alter))
            alter (cdr alter))))
  (while ex
    (setq _isnr nil
          pr    (strcat "\n"
                        prom
                        " "
                        (if _wskaz
                          "numer"
                          "punkt")
                        przyr
                        " albo ["
                        (if _wskaz
                          "Punkt"
                          "Numer")
                        altpr
                        "]: "))
    (initget 128
             (strcat (if _wskaz
                       "Punkt"
                       "Numer")
                     altin))
    (if _wskaz
      (setq p (entsel pr))
      (if prev
        (setq p (getpoint prev pr))
        (setq p (getpoint pr))))    
    (if (and p (= (type p) 'STR))
      (progn (setq ex     (in p '("Punkt" "Numer"))
                   _wskaz (or (= p "Numer") (and _wskaz (/= p "Punkt"))))
             (if (and (null ex) (not (in p __alt)))
               (progn (setq ex nil
                            #nr_pik p
                            _isNr T)
                      (if (setq ok (__lookN #nr_pik))
                        (setq EnPkt (cadr ok)
                              p     (casc 10 (entget EnPkt))))
                      (if (not ok)
                        (progn (princ (strcat "\nNie odnaleziono punktu " #nr_pik "..."))
                               (setq ex T
                                     p  nil))
                        (progn (redraw)
                               (if #zoomTo
                                 (aX-zoomCenterM p)))))))
      (setq ex nil)))
  (cond ((and _wskaz (listp p))
         (setq e p) 
         (if (and e (setq w (casc 2 (entget (car e)))) (in w &Lpkt))
           (progn (setq e     (car e)
                        EnPkt e
                        p     (casc 10 (entget e)))
                  (princ (strcat "[" (setq #nr_pik (casc 1 (entget (entnext e)))) "]\n")))        
           (setq p nil)))
        ((and (null _isnr) p (listp p))          
         (setq #nr_pik (NrPik p))           
         )
        (T (princ))) 
  (setvar #osmode oldtr)   
  (if p
    (changePointType code))   
  (if (and p (listp p))
    (_3dz p)
    p))

(defun GetPtZ  (%prom %przyr %alter %prev %code / sDwaPunkty sJedenPunkt result dwaPunkty pmt)
  (defun dwaPunkty  (/ p1 p2 wynik)
    (setq wynik nil)       
    (if (setq p1 (GetPointZ %prom (strcat %przyr ", (pierwsza szyna)") %alter %prev %code))
      (progn (if (listp p1)
               (progn (if (setq p2 (GetPointZ "Druga szyna," "" nil p1 %code))
                        (setq wynik (SrWsp p1 p2)
                              #wybraneDwaPunkty T)))
               (progn (setq wynik p1)
                      (if (= wynik sJedenPunkt)
                        (setq %alter            (subst sDwaPunkty sJedenPunkt %alter)
                              wynik             (GetPointZ %prom %przyr %alter %prev %code)
                              #wybraneDwaPunkty nil))))))
    wynik)
  (if #osToru
    (progn (setq sDwaPunkty  "dwieSzyny"
                 sJedenPunkt "OS(o)")
           (if #wybraneDwaPunkty
             (setq %alter (append %alter (list sJedenPunkt)))
             (setq %alter (append %alter (list sDwaPunkty))))))
  (if (and #osToru #wybraneDwaPunkty)
    (setq result (dwaPunkty))
    (setq result (GetPointZ %prom %przyr %alter %prev %code)))
  (if result
    (if #osToru
      (cond ((= result sDwaPunkty)
             (setq %alter (subst sJedenPunkt sDwaPunkty %alter)
                   result (dwaPunkty)))
            ((= result sJedenPunkt)
             (setq %alter            (subst sDwaPunkty sJedenPunkt %alter)
                   result            (GetPointZ %prom %przyr %alter %prev %code)
                   #wybraneDwaPunkty nil)))))
  result)

(defun GetPt  (prom przyr alter prev code / a)
  (setq a (GetPtZ prom przyr alter prev code))
  (if (and a (listp a))
    (setq a (_2D a)))
  a)

(defun _findBlock  (pk lstBl / filter ss result)
  (setq result nil
        filter (list (cons 0 #cINSERT) '(-4 . "<OR")))
  (foreach & lstBl (setq filter (append filter (list (cons 2 &)))))
  (setq filter (append filter (list '(-4 . "OR>") '(-4 . "=,=,*") (cons 10 pk)))
        ss     (ssget "_X" filter))
  (if (and ss (> (sslength ss) 0))
    (setq result (list (casc 2 (entget (ssname ss 0))) (ssname ss 0))))
  (_mnil '(ss))
  result)

(defun _findEntitySS  (pk cir filter)
  (ssget "_C"
         (list (- (car pk) cir) (- (cadr pk) cir))
         (list (+ (car pk) cir) (+ (cadr pk) cir))
         (append filter (list '(-4 . "=,=,*") (cons 10 pk)))))

(defun _findEntity  (pk cir filter / ss _ret l len)
  (setq l  0
        ss (_findEntitySS pk cir filter))
  (if (and ss (> (setq len (sslength ss)) 0))
    (while (< l len)
      (setq _ret (append _ret (list (list (casc 1 (entget (entnext (ssname ss l)))) (ssname ss l))))
            l    (1+ l))))
  (_mnil '(ss len l))
  _ret)

(defun _findEntityOneToler  (pk filter Toler / ss _ret l)
  (setq _ret nil
        l    0
        ss   (ssget "_C"
                    (list (- (car pk) #wsp) (- (cadr pk) #wsp))
                    (list (+ (car pk) #wsp) (+ (cadr pk) #wsp))
                    filter))
  (if (and ss (> (sslength ss) 0))
    (while (and (null _ret) (< l (sslength ss)))
      (if (equal (_2d (casc 10 (entget (ssname ss l)))) (_2d pk) Toler)
        (if (entnext (ssname ss l))
          (setq _ret (list (casc 1 (entget (entnext (ssname ss l)))) (ssname ss l)))
          (setq _ret (list (ssname ss l)))))
      (setq l (1+ l))))
  _ret)

(defun _findEntityOne (pk filter)
  (_findEntityOneToler pk filter 0.001))

(defun _findPikLst (pk) (_findEntity pk #wsp (list (cons 0 #cINSERT) #ConsAllPikStr)))

(defun NrPik  (pk / tr nr _r)
  (if pk
    (progn (setq tr (getvar #osmode))
           (setvar #osmode T0)
           (if (setq _r (_findPik pk))
             (progn (setq nr    (car _r)
                          EnPkt (cadr _r))
                    (princ (strcat "[" nr "]\n")))
             (setq nr    ""
                   EnPkt nil))
           (setvar #osmode tr))
    (setq nr ""))
  nr)

(defun start_tryb (os)
  (if TrybCpp
    (progn
      (if (null (CreatedByMapa_SG))
        (C:STANDARD)
        (msg_standard))
      (OknoZrodloDanychIF)
      (Tryb os)
    )
    nil))

(defun _getDwgName () (vl-filename-base (getvar #dwgname)))

(defun _getFullDwgName () (strcat (getvar #dwgpref) (_getDwgName)))

(defun _getfiled  (plik / dcl_id do_a do_c do_w)
  (defun do_a () (setq plik (get_tile "nazwa")) (done_dialog))
  (defun do_c () (setq plik nil) (done_dialog))
  (defun do_w  (/ ff nazwa)
    (setq nazwa (get_tile "nazwa"))
    (if (setq ff (getfiled "Wybierz plik" nazwa (substr (vl-filename-extension plik) 2) 7))
      (set_tile "nazwa" ff)))
  (if (and (>= (setq dcl_id (load_dialog #msg_dcl_file)) 0) (new_dialog "podaj_plik" dcl_id))
    (progn (set_tile "nazwa" plik)
           (mode_tile "nazwa" 2)
           (action_tile "accept" "(do_a)")
           (action_tile "cancel" "(do_c)")
           (action_tile "wybierz" "(do_w)")
           (start_dialog)
           (unload_dialog dcl_id)))
  plik)

(defun _appendfile  (plik / _app _id w_next do_a)
  (defun do_a  (/ _a)
    (setq _a (get_tile "append"))
    (done_dialog 1)
    (if (= _a "dolacz")
      (setq _app "a")))
  (setq _app "w")
  (if (findfile plik)
    (if (>= (setq _id (load_dialog #msg_dcl_file)) 0)
      (progn (setq w_next 3)
             (while (and (= w_next 3) (findfile plik) (new_dialog "file_app" _id))
               (set_tile "append" "dolacz")
               (action_tile "accept" "(do_a)")
               (action_tile "cancel" "(setq _app nil)(done_dialog 0)")
               (action_tile "zmien" "(done_dialog 3)")
               (setq w_next (start_dialog))
               (if (= w_next 3)
                 (setq plik (_getfiled plik))))
             (unload_dialog _id))
      (setq _app nil))
    (setq _app "w"))
  _app) 

(defun _getfiled->append  (plik / op)
  (if (and (setq #nazwaPliku (_getfiled plik)) (setq op (_appendfile #nazwaPliku)))
    (open #nazwaPliku op)
    nil))

(defun xGetAttr  (sCode sWej sVal / wyn rys %% ww)
  (if (null sWej)
    (setq sWej ""))
  (setq rys '())
;sCode=EGBP04_01
;sWej=NRP^1000^100771|RZG^1000^101.50|RZD^1000^
;sVal=178D
;(princ "sCode=")(princ sCode)(terpri)
;(princ "sWej=")(princ sWej)(terpri)
;(princ "sVal=")(princ sVal)(terpri)
;(getstring "\nI:")
;(princ (entget enpkt (list "*")))
  (if (setq wyn (arxGetAttr sCode sWej sVal))
    (progn
     (foreach %% wyn
       (setq rys (append rys (list (list (StrLeftValue %%) (StrRightValue %%))))))
     (if (wcmatch sCode "SU?P")
       (foreach %% (_podziel_znak sWej "|")
         (setq ww (_podziel_znak %% "^"))
         (if (and ww (= (car ww) "RO>"))
            (setq rys (append rys (list (list (car ww) (strcat (nth 2 ww) "|1005||")))))
         )
       )  
     )    
    ))
;;(princ "wynik")(princ rys)(terpri)
;(print "*************************************")
;(princ (entget enpkt (list "*")))  
  rys)

(defun xj_GetAtrybuty  (&kodObj &listaA propoz oCoords / atWej res lstAt lsRes ite kod WydajUsun item _zr _kg aW assROS)
  (defun WydajUsun  (elem / next i wynik)
    (setq next T
          wynik ""
          i 0)
    (while (and next (< i (length res)))
      (if (= elem (car (nth i res)))
        (progn (setq wynik (cadr (nth i res))
                     res   (del_item_lst (nth i res) res)
                     next  nil)))
      (setq i (1+ i)))
    wynik)
  (setq atWej ""
        lstAt (eval &listaA)) 
  (if propoz
    (progn (if (listp propoz)
             (setq aW     (cadr propoz)
                   propoz (car propoz)))
           (if (and propoz (listp lstAt) (> (length lstAt) 0))
             (setq atWej (strcat (caar lstAt)
                                 "^1000^"
                                 (if (listp propoz)
                                   (car propoz)
                                   #nr_pik))))
           (if (= (type aW) 'STR)
             (if (= atWej "")
               (setq atWej aW)
               (setq atWej (strcat atWej "|" aW)))))
    (if (= (type lstAt) 'STR)
      (setq atWej lstAt)))
  (if (> (strlen atWej) 0)
    (if #globListaPrev
      (setq atWej (strcat #globListaPrev "|" atWej)))
    (setq atWej #globListaPrev))
  (if (and #plinAsCircle (= (type #plinAsCircle) 'REAL))
    (progn
      (if atWej
        (setq atWej (strcat atWej "|UBX^1000^" (itoa (fix (* #plinAsCircle 2E3)))))
        (setq atWej (strcat "UBX^1000^" (itoa (fix (* #plinAsCircle 2E3))))))
      ))
  (if (setq res (xGetAttr (eval &kodObj) atWej (xjObjToCpp oCoords)))
    (progn (setq lsRes res
                 res   '())
           (foreach &  lsRes
             (setq item (_podziel_znak (cadr &) SK_SEP))
             (if (distof (cadr item))
               (setq item (change_item_lst 1 (atoi (cadr item)) item)))
             (setq res (append res (list (list (car &) (car item) (cdr item))))))
           (setq assROS (assoc "ROS" res)
                 lsRes '())
           (if (/= (type lstAt) 'STR)
             (foreach &  lstAt
               (if (null (setq ite (WydajUsun (car &))))
                 (setq ite ""))
               (setq lsRes (append lsRes (list ite)))))     
           (set &listaA lsRes)
           (setq kod (WydajUsun #cKod))
           (set &kodObj kod)

	   ;;; 18-11-2015 aby wyswielac MODEMACRO      
           (if (assoc "ZRD" res)
             (progn (setq _zr (nth 1 (assoc "ZRD" res)))
                    (if (assoc "KRG" res)
                      (setq _kg (nth 1 (assoc "KRG" res))))
                    (displayZrodlo _zr _kg)))
      ))
  res)

(defun xjObjToCpp (_obj / _ret)
  (setq _ret "")
  (if _obj
    (cond ((= (type _obj) 'ENAME)
           (setq _ret (casc 5 (entget _obj))))
          ((listp _obj)
           (if EnPkt
             (setq _ret (casc 5 (entget EnPkt)))
             (setq _ret (strcat (rtos (car _obj) 2 6) SK_SEP (rtos (cadr _obj) 2 6) SK_SEP
                                (if (caddr _opbj)
                                  (rtos (caddr _obj) 2 6)
                                  "0")))))))
  _ret)

(defun xjInsMulti  (sh attrib cod / _id mx my filter what figura ss_tmp ss_wybierz def_cod godlo _cen _rad _ret lastAction noAction l nr w zakres item cech)
  (defun _end  (var)
    (cond ((> var 0)
           (setq zakres (get_tile "zakres")
                 figura (get_tile "punkty"))))
    (setq #scr-pt (done_dialog var)))
  (if (>= (setq _id (load_dialog #msg_dcl_file)) 0)
    (progn (setq what       2
                 figura     "okno"
                 zakres     ""
                 noAction   T
                 lastAction 0
                 def_cod    "*"
                 ss_tmp     '()
                 ss_wybierz '()
                 filter     (list (cons 0 #cINSERT) #ConsAllPikStr))
           (while (and (> what 1) (new_dialog "multi" _id "" #scr-pt))
             (setq mx (dimx_tile "show")
                   my (dimy_tile "show"))
             (start_image "show")
             (slide_image 5 0 mx (- my 5) (strcat "msgz(" sh ")"))
             (end_image)
             (set_tile "punkty" figura)
             (set_tile "zakres" zakres)
             (action_tile "ekran" "(_end 3)")
             (action_tile "okrag" "(_end 4)")
             (action_tile "okno" "(_end 5)")
             (action_tile "poligon" "(_end 6)")
             (action_tile "wszystkie" "(_end 7)")
             (action_tile "wybierz" "(_end 8)")
             (action_tile "accept" "(_end 1)")
             (action_tile "cancel" "(_end 0)")
             (action_tile "zakres" "(if (/= zakres $value)(setq lastAction 0))")
             (setq what (start_dialog))
             (if (and (= what 1) noAction)
               (setq what 5))
             (setq noAction nil)
             (_selectPointsFromDialog
               what 'ss_tmp 'ss_wybierz zakres def_cod 'figura 'godlo filter '#wXY '_cen '_rad 'lastAction))
           (unload_dialog _id)
           (if (and (= what 1) ss_wybierz (> (sslength ss_wybierz) 0))
             (progn (setq _ret (ssadd)
                          cech (xjCechyByKod cod)
                          l    0)
                    (while (< l (sslength ss_wybierz))
                      (setq EnPkt (ssname ss_wybierz l)
                            l     (1+ l)
                            nr    (casc 1 (entget (entnext EnPkt)))
                            w     (casc 10 (entget EnPkt)))
                      (changePointType cod)
                      (if (setq item (_createBlock sh (_3d w) 0 nil))
                        (progn
                          (vlax->PutProperty item cech)
                          (ssadd item _ret)
                          (xjOpiszObiekt item cod attrib))))
                    (prompt (strcat "\n" (itoa l) " blok(w) " (strcase sh) " wstawionych."))))))
  _ret)

(defun xjWymienHasz  (lista def / resL it && ## ii)
  (setq resL '()
        def (EmptyIfNull def))
  (foreach &&  lista
    (setq it '())
    (foreach ##  (nth 2 &&)
      (setq ii ##)
      (if (and (= (type ii) 'STR) (vl-string-position (ascii "#") ii))
        (setq ii (vl-string-subst def "#" ii)))
      (if (and (= (type ii) 'STR) (vl-string-search "&&" ii))
        (setq ii (vl-string-subst (UzupStr (itoa (+ (vl-position (strcase def T) #ltaPWSiec) 1)) "0" 2) "&&" ii)))
      (setq it (append it (list ii))))
    (setq resL (append resL (list (list (car &&) (cadr &&) it)))))
  resL)

(defun xjLayerBySiec  (code atrybuty / siec)
  (setq siec "")
  (if (assoc "ROS" atrybuty)
      (setq siec (strcase (car (_podziel_znak (cadr (assoc "ROS" atrybuty)) "#")))))
  (if (and (/= siec "")
           (wcmatch code "SUSM04*,SUUS15*,SUUS22*,SUUS24*,SUUS25,SUUS27*,SUUS29*,SUUS30*,SUUS31*,SUSM*")
           (not (wcmatch code "SUSM_P_??")))
    (list (strcat (substr code 1 4) "_" siec))
    (arxGetLayer code)))

(defun GetAtrybFrom  (blokName Attrib / lsAttr rez &&)
  (setq lsAttr (read_attdefName->block blokName))  
  (if (> (length lsAttr) 0)
    (progn (setq rez '())
           (foreach && lsAttr (setq rez (append rez (list (xjGetCADR (car &&) Attrib)))))
           (setq lsAttr rez)))
  lsAttr)

(defun defBlHasAttrib  (nazwa / tbl res obj)
  (setq res nil
        tbl (tblsearch "BLOCK" nazwa))
  (if tbl
    (progn (setq obj (casc -2 tbl))
           (while obj
             (if (= (casc 0 (entget obj)) #cATTDEF)
               (setq res T))
             (setq obj (entnext obj)))))
  res)

(defun xj_insBlock  (tr shap podkr ang prop code / _ret jeszcze alter pk awej hh atrybuty lay _ret oldOs an %latr AttObj lst_w && attc %ros stb)
  (if (or (and tr (start_tryb tr)) (null tr))
    (progn (if (and tr (/= (dwg_LokCfg) 1))
             (setvar #osmode tr))
           (setq jeszcze T
                 alter   (if (and (definiuj_blok shap nil) (null ang) (not (defBlHasAttrib shap)))
                           '("Wiele")
                           nil))
           (CodeMessage code)
           (while jeszcze
             (setq #pInsert nil)
             (if (setq pk (GetPtZ #Wskaz "" alter nil code))
               (progn (setq %latr (read_attdefName->block shap)
                            hh    (if (listp pk)
                                    (caddr pk)
                                    0)) 
                      (if (/= hh 0)
                        (progn
                          ;;;; k1                       
                          (cond ((assoc "UJY" %latr)
                                 (setq prop (list prop (strcat "UJY^1000^" (rtos hh 2 #prec)))))
                                ((in code (list "WLD" "WLM" "WLZ" "ZAS" "KRW" "KRA"))
                                 (setq prop (list prop (strcat "UJO^1000^" (rtos hh 2 #prec)))))
                                ((= code "BPO")
                                 (setq prop (list prop (strcat "UDG^1000^" (rtos hh 2 #prec)))))
                                ((wcmatch code "UK?")
                                 (setq prop (list prop (strcat "UJ" (strcase (substr code 3 1)) "^1000^" (rtos hh 2 #prec)))))
                                (T
                                  (setq prop (list prop (strcat "RZG^1000^" (rtos hh 2 #prec) "|RZD^1000^")))))))
                      (if (setq atrybuty (xj_GetAtrybuty 'code '%latr prop pk))
                        (progn (changePointType code)
                               (setq attc atrybuty
                                     lay  (car (arxGetLayer code)))
                               (if (wcmatch code "SM?,TP?,SR?,TO?")
                                 (progn                                 
                                   (setq shap code)
                               ))
                               (if (in code (list "TRO" "ZUR"))
                                 (setq shap (strcat code (cadr (assoc "TYP" atrybuty)))))
;;;Mapa17
                               (if (= code "EGPG")
                                 (progn
                                   (if (assoc "STB" atrybuty)
                                     (setq stb (cadr (assoc "STB" atrybuty)))
                                     (setq stb "1"))
                                   (if (not (distof stb))
                                     (setq stb "1"))
                                  (if (> (distof stb) 2)
                                     (setq stb "a")
                                     (setq stb "b"))                                     
                                   (setq shap (strcat code "_" stb))
                                 )
                               )
                               (if (= code "SUPW")
                                 (progn
                                   (setq attc (string->Def-If-Empty (xjGetCADR "GKU" atrybuty) "o"))
                                   (cond ((member attc '("k" "p"))
                                          (setq shap attc
                                                ang #obrot))
                                         (T (setq shap "o")))
                                   (setq shap (strcat code "_" shap))
                                 )
                               )  
                               (if (setq jeszcze (definiuj_blok shap T))
                                 ;; ponownie, po zmianie typu sieci
                                 (progn (if (not %latr)
                                          (setq %latr (GetAtrybFrom shap atrybuty)))
                                  
                                        (MakeLay lay)
                                        (cond ((= pk "Wiele")
                                               (setq jeszcze nil
                                                     _ret    (xjInsMulti shap atrybuty code)))
                                              (T
                                               (setq jeszcze #multiInsert
                                                     oldOs   (getvar #osmode))
                                               (setvar #osmode T0)
                                               (if (<= (caddr pk) 0.0)
                                                 (setq pk (_3D pk)))
                                               (setq an       (if &adr
                                                                (getAng ang pk)
                                                                0.0)
                                                     #pInsert pk)


                                               
                                               (if (setq _ret (_createBlock shap pk an %latr))
                                                 (progn
                                                   ;;; 2016-08-30
;;;(print (xjCechyByKod code)) (getstring)
                                                        (vlax->PutProperty _ret (xjCechyByKod code))
                                                        (setq AttObj (if (arxHasAttributes _ret)
                                                                       (vlax-safearray->list (vlax-variant-value (vla-GetAttributes (vlax-ename->vla-object _ret))))
                                                                       nil)
                                                              lst_w  '())                                                 
                                                        (if AttObj
                                                          (foreach & AttObj (setq lst_w (append lst_w (list (getTextInsertionPoint &))))))                                                  
                                                        (if (and ang (null &adr))
                                                          (xjMovRot _ret 4))                                                
                                                        (xjOpiszObiekt _ret code atrybuty)                                                   
                                                        (if (and AttObj (null &adr) (= (length AttObj) (length %latr)))
                                                          (progn (mapcar '(lambda (Att Txt Ws )
                                                                            (TextPropByStyle Att)
                                                                            (vla-put-Rotation Att 0.0)
                                                                            (vla-put-TextString  Att (car (_podziel_znak Txt "#")))
                                                                            (msg-vla-put-TextInsertionPoint Att Ws))
                                                                         AttObj
                                                                         %latr
                                                                         lst_w)
                                                                 (if podkr
                                                                   (_drawPodkreslenie (entnext _ret)))
                                                                 (if (not #GSTAR)
                                                                   (if AttObj
                                                                     (progn (xjPWstAtr _ret) (odnosnik_podkreslenie _ret (entnext _ret)))))))
                                                        (if (dwg_AutoOrder)
                                                          (ModOrder _ret))                                                   
                                                        (setvar #osmode oldOs))))))))
                        (progn (foreach &&  #pkrUndo
                                 (if &&
                                   (entdel &&)))
                               (setq #pkrUndo nil)
                               (setq jeszcze nil))))
               (setq #plin nil
                     jeszcze nil)))
           (if tr
             (lovar))))
  _ret)

(defun xjOneInsBlock  (tr shap podkr ang prop code)
  (setq #multiInsert nil)
  (xj_insBlock tr shap podkr ang prop code))

(defun xjDefOneInsBlockRot (code)
  (xjOneInsBlock T8 code nil #obrot nil code))

(defun xjDefOneInsBlockNoRot (code)
  (xjOneInsBlock T8 code nil nil nil code))

(defun xjMultiInsBlock (tr shap podkr ang prop code)
  (setq #multiInsert T)
  (xj_insBlock tr shap podkr ang prop code)
  (setq #multiInsert nil)
  (princ))

(defun GetAng  (ang p / an _getln)
  (defun _getln  (aa obr / e en)
    (if (and (setq e (nentsel #WskazOdcinek))
             (in (casc 0 (setq en (entget (setq e (car e))))) (list #cLINE #cVERTEX)))
      (progn (setq aa (angle (casc 10 en) (_get11 e)))
             (if obr
               (setq aa (+ aa #pi2)))
             (if (>= aa (* pi 2))
               (setq aa (- aa (* pi 2))))
             (if (< aa pi)
               (setq aa (+ aa pi)))))
    aa)
  (var_initialize '#prec (getvar "LUPREC"))
  (if (equal (type ang) 'SYM)
    (setq ang 100.0))
  (if ang
    (progn (initget "LProstop LRwnoleg")
           (setq an (getangle p (strcat "\nLProstop/LRwnoleg/Kt obrotu [" (rtos ang 2 #prec) "]: ")))
           (cond ((equal an "LProstop") (setq an (_getln ang nil)))
                 ((equal an "LRwnoleg") (setq an (_getln ang T)))
                 ((null an)
                  (setq an (if &adr
                             (- #pi2)
                             0.0)))))
    (setq an 0.0))
  (if &adr
    (setq an (+ an #pi2)))
  (RGr (lspgeo an))) 

(defun UnErr (p) (prompt (strcat "\nTo nie jest " p "...")) (princ))

(defun UsSym  (pr Nam / e a)
  (if (tryb T0)
    (progn (while (setq a (entsel (strcat #Wskaz pr " do usunicia: ")))
             (setq e (entget (car a)))
             (if (and (equal (casc 0 e) #cINSERT) (in (casc 2 e) Nam))
               (object_link->Erase (car a))
               (UnErr pr)))
           (lovar))))

(defun MoveBl  (bl pr prb movZ / p w z e nxy ew xS yS)
  (if (start_tryb T0)
    (progn (setq z 0.0
                 p (entsel (strcat #Wskaz pr ": ")))
           (if (and p (equal (casc 0 (entget (setq p (car p)))) #cINSERT) (in (casc 2 (entget p)) bl))
             (progn (nrPik (casc 10 (entget p)))
                    (setq e (entget p)
                          w (casc 10 e))
                    (setq nyx (getpoint w (strcat "\nWsprzdne Y,X [" (rtos (car w) 2 #prec) "," (rtos (cadr w) 2 #prec) "]: ")))
                    (if (null nyx)
                      (setq nyx w))
                    (if movZ
                      (setq z (msg_getreal "Wsprzdna Z" (caddr w) #precWSU)))
                    (if !command-s
                      (command-s "_.MOVE" p "" w (list (car nyx) (cadr nyx) z))
                      (command "_.MOVE" p "" w (list (car nyx) (cadr nyx) z)))
                    (if (and movZ (in (casc 2 e) '("WSU" "WSP")))
                      (progn (setq ew (entget (entnext p))
                                   ew (subst (cons 1 (rtos z 2 (prec_wys (casc 2 e)))) (assoc 1 ew) ew))
                             (entmod ew)
                             (entupd p)))
                    (modify_date->object p nil))
             (UnErr prb))
           (lovar)))
  (princ))

(defun setUser  (Use fn)
  (while (= (getvar Use) 0)
    (prompt "Zawieszone dziaanie polecenia...")
    (apply fn '())
    (prompt "Kontynuacja.\n")))

(defun _wspOdn  (obj / pmin pmax pws dx rot pp pk h mt)
  (ename->vlaObj 'obj)
  (if (= (vla-get-ObjectName obj) "AcDbAttribute")
    (progn (setq pws (getTextInsertionPoint obj)
                 mt  (CopyAttribToMtext obj))
           (if mt
             (progn (vla-GetBoundingBox mt 'pmin 'pmax) (vla-delete mt))))
    (progn (if (= (vla-get-ObjectName obj) "AcDbMText")
             (setq pws (vlax-safearray->list (vlax-variant-value (vla-get-InsertionPoint obj))))
             (setq pws (getTextInsertionPoint obj)))))
  (setq h   (vla-get-Height obj)
        rot (vla-get-Rotation obj))
  (vla-put-Rotation obj 0.0)
  (vla-GetBoundingBox obj 'pmin 'pmax)  
  (setq pmin (vlax-safearray->list pmin)
        pmax (vlax-safearray->list pmax)
        dx   (/ h 5.0)
        pp   (list (car pmin) (- (cadr pmin) dx))
        pk   (list (car pmax) (cadr pp)))
  (vla-put-Rotation obj rot) 
  (list (polar pws (+ (angle pws pp) rot) (distred pws pp))
        (polar pws (+ (angle pws pk) rot) (distred pws pk))))

(defun _wspOdnAny (obj / pmin pmax dx rot pp pk pws)
  (ename->vlaObj 'obj)
  (setq pws (casc 10 (entget (vlax-vla-object->ename obj)))
        rot (vla-get-Rotation obj))
  (vla-put-Rotation obj 0.0)
  (vla-GetBoundingBox obj 'pmin 'pmax)
  (setq pmin (vlax-safearray->list pmin)
        pmax (vlax-safearray->list pmax)
        dx (/ (- (cadr pmax) (cadr pmin)) 7.0)
        pp (list (car pmin) (- (cadr pmin) dx))
        pk (list (car pmax) (cadr pp)))
  (vla-put-Rotation obj rot)
  (list (polar pws (+ (angle pws pp) rot) (distred pws pp)) (polar pws (+ (angle pws pk) rot) (distred pws pk))))

(defun _odnosnikOnly  (item od / pk en kn podkr)
  (setq en (entget item))
  (if (or (= (casc 0 (entget item)) #cTEXT) (= (casc 0 (entget item)) #cATTRIB) (= (casc 0 (entget item)) #cMTEXT))
    (setq pk (_wspOdn item))
    (setq pk (_wspOdnAny item)))
  (setq kn    (cadr pk)
        pk    (car pk)
        podkr (_createPolyline
                (casc 8 en)
                0
                (cond ((< (distRed pk od) (distRed kn od)) (list od pk kn))
                      (T (list od kn pk))))
        item  (main_item item)
        ) 
  (vlax->PutProperty
    podkr
    (list (list 'Linetype #cContinuous)
          (list 'Lineweight (vla-get-Lineweight (vlax-ename->vla-object item)))
          (list 'Color (vla-get-Color (vlax-ename->vla-object item)))))
  ;;; 24.11.2020 usuniety kod LOD
  (write_exdata
    podkr
    (list (list #cons1000LINK (cons 1005 (casc 5 (entget item))))))
  (mod_exdata item (list (list "LOD" (casc 5 (entget podkr)) 1005)))
  podkr)

(defun _drawOdnosnik  (item / od)
  (if (setq od (getpoint #WskKonOdn))
     (_odnosnikOnly item od)))

(defun _drawPodkr  (item double / pk kn en podkr ht)
  (setq en (entget item)
        ht (casc 40 en)
        pk (_wspOdn item)
        kn (cadr pk)
        pk (car pk))
  (setq podkr (_createPolyline (casc 8 en) 0 (list pk kn))
        item  (main_item item))
  (vla-put-Linetype (vlax-ename->vla-object podkr) #cContinuous)
  (append_link podkr item "PODK" T)
  (if double
    (progn (setq secPodkr (_createPolyline
                            (casc 8 en)
                            0
                            (list (polar pk (- (angle pk kn) #pi2) (* #wsp (/ ht 4))) (polar kn (- (angle pk kn) #pi2) (* #wsp (/ ht 4))))))
           (vla-put-Linetype (vlax-ename->vla-object secPodkr) #cContinuous)
           (append_link secPodkr item "PODK1" T)))
  podkr)

(defun _drawPodkreslenie (item)
  (_drawPodkr item nil))

(defun xjDrawPodkr (item / res)
  (setq res (XJPodkreslenie (casc 5 (entget item))))
  (if (and res (/= res ""))
    (progn
      (vla-put-color (vlax-ename->vla-object (handent res)) (vla-get-Color (vlax-ename->vla-object item)))
      (handent res)
    )
    nil))

(defun xjDrawOdnosnik (item pt / res lan)
  (setq lan (strcat (casc 5 (entget item)) SK_SEP (rtos (car pt) 2 6) SK_SEP (rtos (cadr pt) 2 6) SK_SEP
                    (if (caddr pt) (rtos (caddr pt) 2 6) "0.0")))
  (setq res (XJOdnosnik lan))
  (if (and res (/= res ""))
    (progn
      (vla-put-color (vlax-ename->vla-object (handent res)) (vla-get-Color (vlax-ename->vla-object item)))
      (handent res)
    )  
    nil))

(defun _drawDoublePodkr (item)
  (_drawPodkr item T))

(defun xjDrawSkarpa  (pl1 pl2 Lay &wierz / res wynik & vt)
  (if (and pl1 (null pl2))
    (WydzielKrawedzieSkarpy 'pl1 'pl2))
  (setq vt (polyline->wierzcholki pl1))
  (set &wierz (list (car vt) (last vt)))
  (setq wynik (ssadd)
        res   (XJSkarpa (strcat (casc 5 (entget pl1)) SK_SEP (casc 5 (entget pl2)) SK_SEP Lay)))
  (if (= (vla-get-visible (vlax-ename->vla-object pl1)) :vlax-false)
    (entdel pl1))
  (if (= (vla-get-visible (vlax-ename->vla-object pl2)) :vlax-false)
    (entdel pl2))
  (if (> (length res) 0)
    (foreach & res (ssadd (handent &) wynik)))
  wynik)

(defun xjDrawRow (pl1 pl2 Lay / res wynik &)
  (setq wynik (ssadd)
        res   (XJRowMel (strcat (casc 5 (entget pl1)) SK_SEP (casc 5 (entget pl2)) SK_SEP Lay)))
  (if (> (length res) 0)
    (foreach & res (ssadd (handent &) wynik)))
  wynik)

(defun _instxt  (prom lay st ang def / pk txt en ret os w1 w2)
  (setq os (getvar #osmode))
  (setvar #osmode T0)
  (if (null def)
    (setq txt (getstring 1 (strcat "\n" prom ": ")))
    (setq txt def))
  (if (and (/= txt "") (setq pk (getpoint (strcat "\n" prom " -> Punkt wstawienia tekstu: "))))
    (progn (cond (ang
                  (initget "Linia")
                  (setq ang (getangle pk "\nLinia/Kt obrotu [100]: "))
                  (cond ((and (= ang "Linia")
                              (setq en (nentsel #WskazLinie))
                              (in (casc 0 (entget (car en))) (list #cLINE #cVERTEX #cPOLYLINE #cLWPOLYLINE #cMLINE)))
                         (entsel->Odcinek en 'w1 'w2)
                         (setq ang (+ #pi2 (angle w1 w2)))
                         (if (>= ang (* pi 2))
                           (setq ang (- ang (* pi 2))))
                         (if (and (> ang 0) (<= ang pi))
                           (setq ang (+ ang pi)))))))
           (if (null ang)
             (setq ang (+ #pi2 pi)))
           (setq ang (RGr (LspGeo ang)))
           (setq ret (LaWre lay pk st ang txt nil))))
  (setvar #osmode os)
  ret)

(defun _createTextOld (%layer %start %styl %angle %tekst %Align / res oa hh vStyl sf)
  (if %layer
    (arxMakeLayer %layer))
  (var_initialize '#def_wysTxt (getvar "TEXTSIZE"))
  (cond ((= (strcase %styl) #cSTANDARD)
         (setq oa 0.0
               sf 1.0
               hh #def_wysTxt))
        (T (if (null (tblsearch "STYLE" %styl))
             (arxMakeStyle %styl))
         (if (null (setq vStyl (vla-Item (vla-get-TextStyles #acadDoc) %styl)))
           (setq %styl nil
                 sf 0.9
                 oa 0.0)
           (setq oa (vla-get-ObliqueAngle vStyl)
                 sf (vla-get-Width vStyl)
                 hh (vla-get-Height vStyl)))))
  (if (or (null hh) (= hh 0.0))
    (progn
      ;(prompt (strcat "\nUwaga! Styl tekstu [" %styl "] nie posiada okrelonej wysokoci.\nPrzyjto domyln wysoko tekstu!"))
      (setq hh #def_wysTxt)))
  (if #D19_SkalujText
    (setq hh (* hh #D19_SkalujText)))
  (if (vl-string-search "#" %tekst) 
    (progn
      (setq %tekst (msg-string-subst "\n" "#" %tekst))
      (setq res (vla-AddMText #ModelS (vlax-3d-point %start) 0 %tekst))
      (vla-put-AttachmentPoint res acAttachmentPointMiddleCenter)
      (vla-put-StyleName res %styl)
      (vla-put-Layer res %layer)
      (vla-put-Height res hh)
      (setq res (vlax-vla-object->ename res))
    )  
  (if (and %styl (setq res (vla-AddText #ModelS %tekst (vlax-3d-point %start) hh)))
    (progn
      (vla-put-Alignment res %Align)
      (msg-vla-put-TextInsertionPoint res %start)
      (vla-put-StyleName res %styl)
      (if (null #LTVer)
         (vla-put-ObliqueAngle res oa))
      (vla-put-ScaleFactor res sf)
      (vla-put-Layer res %layer)  
      (vla-put-Rotation res (- #pi2 (GrR %angle))) 
      (setq res (vlax-vla-object->ename res))
      ))
    )
  res)

(defun MTextOrText ()
  #MTextOrText
  )

(defun _createText  (%layer %start %styl %angle %tekst %Align / res oa hh vStyl)
  (if %layer
    (arxMakeLayer %layer))
  (var_initialize '#def_wysTxt (getvar "TEXTSIZE"))
  (cond ((= %styl #cSTANDARD)
         (setq oa 0.0
               hh #def_wysTxt))
        (T
         (if (null (tblsearch "STYLE" %styl))
           (arxMakeStyle %styl))
         (if (null (setq vStyl (vla-Item (vla-get-TextStyles #acadDoc) %styl)))
           (setq %styl nil
                 oa    0.0)
           (setq oa (vla-get-ObliqueAngle vStyl)
                 hh (vla-get-Height vStyl))))) 
  (if (or (null hh) (= hh 0.0))
    (progn
      (setq hh #def_wysTxt)))
  (if #D19_SkalujText
    (setq hh (* hh #D19_SkalujText)))
  (if %styl
    (progn (if (or (MTextOrText) (vl-string-search "#" %tekst))
             (progn (setq %tekst (msg-string-subst "\n" "#" %tekst))
                    (setq res (vla-AddMText #ModelS (vlax-3d-point %start) 0 %tekst))
                    (if res
                      (progn (vla-put-AttachmentPoint res %Align)
                             (vla-put-StyleName res %styl)
                             (vla-put-Layer res %layer)
                             (vla-put-Height res hh)
                             (vla-put-Rotation res (- #pi2 (GrR %angle)))
                             (vla-put-InsertionPoint res (vlax-3d-point %start))
                             (setq res (vlax-vla-object->ename res)))))
             (progn (setq res (vla-AddText #ModelS %tekst (vlax-3d-point %start) hh))
                    (if res
                      (progn (if (= %Align acAttachmentPointMiddleCenter)
                               (setq %Align acAlignmentMiddleCenter))
                             (vla-put-Alignment res %Align)
                             (msg-vla-put-TextInsertionPoint res %start)
                             (vla-put-StyleName res %styl)
                             (if (null #LTVer)
                               (vla-put-ObliqueAngle res oa))
                             (vla-put-Layer res %layer)
                             (vla-put-Rotation res (- #pi2 (GrR %angle)))
                             (setq res (vlax-vla-object->ename res))))))))
  res)

(defun LaWre (lay start _styl ang tekst code)
  (if #LTVer
    (_createTextOld lay start _styl ang tekst acAlignmentMiddleCenter)
    (_createText lay start _styl ang tekst acAttachmentPointMiddleCenter)))

(defun _modFill (txt / e)
  (arxMTextModFill txt))

(defun Text->Layer  (tr Lay _lw _styl ang fn code / oldlw tekst pkt osm item dLod etyk)
  (if (or (null tr) (start_tryb T0))
    (progn (var_initialize '#lst_str "")
           (var_initialize '#txt_lod "0")
           (var_initialize '#txt_pod "0")     
           (if (and code tr)
             (CodeMessage code)
             (progn (setq osm (getvar #osmode)) (setvar #osmode 0)))
           (if _lw
             (progn (setq oldlw (getvar "CELWEIGHT"))
                    (setvar "CELWEIGHT" (fix (* (nth (pos_skala 'skala) _lw) 10)))))
           (if fn
             (setq tekst (apply fn '()))
             (progn
               (if code
                 (setq etyk (nth 2 (arxWydajKod code)))
                 (setq etyk "Tekst"))
               (if (= etyk "")
                 (setq etyk "Tekst"))
               (setq tekst (dialog_tekst etyk '#lst_str))))
           (if (member tekst #voidList)
             (setq tekst nil))
           (if (and tekst (> (strlen tekst) 0))
             (progn
               (setq pkt (cadr (grread 1))
                          dLod (vl-string-search "%%u" tekst))
                    (if dLod
                      (setq tekst (vl-string-subst "" "%%u" tekst)))
                    (setq item (LaWre Lay pkt _styl 100 tekst code))
                    (cond ((or dLod (= #txt_lod "1"))
                           (if (and object
                                    (entget object)
                                    (= (casc 0 (entget object)) #cINSERT))
                             (_odnosnikOnly item (casc 10 (entget object)))
                             (_drawOdnosnik item)))
                          ((= #txt_pod "1") (_drawPodkreslenie item)))
                    (xjMovRot item
                              (+ 2
                                 (if ang
                                   4
                                   0)))
                    (odnosnik_podkreslenie item item)
               ))
           (if _lw
             (setvar "CELWEIGHT" oldlw))
           (if tr
             (lovar)
             (setvar #osmode osm))))
  item)

(defun _modtxt  (old new ent / en)
  (if (/= old new)
    (progn (setq en (subst (cons 1 new) (assoc 1 (entget ent)) (entget ent))) (entmod en) (entupd ent))))

(defun Polylinia->TypPunktu  (plin typ code)
  (if (null typ)
    (setq typ (DefaultTyp code)))
  (if (or (= (casc 0 (entget plin)) #cPOLYLINE) (= (casc 0 (entget plin)) #cLWPOLYLINE))
    (foreach & (Polyline->wierzcholki plin)
      (if (setq EnPkt (_findPik &))
        (_chInsert (cadr EnPkt) typ code)))))

(defun JoinTwoPline  (plineL plineR / vtsL vtsR)
  (setq vtsL (Polyline->wierzcholki plineL)
        vtsR (Polyline->wierzcholki plineR))
  (if (< (distred (last vtsL) (last vtsR)) (distred (last vtsL) (car vtsR)))
    (setq vtsR (reverse vtsR)))
  (append vtsL vtsR))

(defun xjLnOdsunieta  (code hleft hright _fn fnText _fnEx isClose / Cechy cLayer ssa eNameL eNameR ssd atrybuty latr done _draw _pods _drKrawedz ssUndo %% %cl pObj pWs els Zamien oExd)
  (defun Zamien  (&wierz / wierz result it)
    (setq wierz '()
          result '())
    (foreach &  (eval &wierz)
      (setq it     (car &)
            wierz  (append wierz (list (list (car it) (cadr it) (caddr it))))
            result (append result (list (append it (list (cadr &)))))))
    (set &wierz wierz)
    result)
  (defun _pods  (start h ang)
    (list (+ (car start) (startX h (+ ang 100.0))) (+ (cadr start) (startY h (+ ang 100.0)))))
  (defun _draw  (wa wb eName / Obj pt iL Vts ang)
    (cond (eName
           (setq Vts (Polyline->wierzcholki eName)
                 iL  (1- (length Vts))
                 ang (- (angle (nth (- iL 1) Vts) (nth iL Vts)) (angle wa wb))
                 pt  (inters (nth (- iL 1) Vts) (nth iL Vts) wa wb nil))
           (if pt
             (setq Vts (change_item_lst iL pt Vts)))
           (setq Vts (append Vts (list wb)))
           (entdel eName))
          (T (setq Vts (list wa wb))))
    (_createPolyline (car cLayer) 0 Vts))
  (defun _drKrawedz  (title hleft hright / selO ex od do fst pr wal wbl war wbr ang _cof count vlaPlin is3D props)
    (if title
      (prompt (strcat "\n->>> " title "...")))
    (setq selO "wskazObiekt")
    (if (setq do (GetPt #from "u" (list selO) nil code))
      (progn
        (cond ((= do selO)
               (setq %cl nil)
               (if (setq pObj (_jedenOb code '%cl))
                 (progn (setq is3D    (= (vla-get-ObjectName (vlax-ename->vla-object pObj)) "AcDb3dPolyline")
                              props   (append (xjCechyByKod code) (list (list 'Layer (car cLayer))))
                              pWs     (Polyline->wierzcholkiLuki pObj)
                              els     (Zamien 'pWs))

                        (if is3D
                          (progn
                            (setq vlaPlin (vlaCreate3dPoly pWs (append props (list (list 'Closed (if %cl :vlax-true :vlax-false)))))
                                  eNameL (vlax-vla-object->ename vlaPlin))
                          )  
                          (progn
                            (setq eNameL  (_createPolyline (car cLayer) (if %cl 1 0) pWs)
                                  vlaPlin (vlax-ename->vla-object eNameL)                              
                                  count 0)
                            (foreach &  els
                              (if (eq (length &) 4)
                                (vla-SetBulge vlaPlin count (nth 3 &)))
                              (setq count (1+ count)))
                            (vlax->PutProperty eNameL (append (xjCechyByKod code) (list (list 'Layer (car cLayer)))))))
                        (ssadd eNameL ssUndo)
                        (if #selErase
                          (entdel pObj)))))
              (T
               (setq ex  T
                     fst nil)
               (while ex
                 (if (null fst)
                   (setq fst '("oDleg"))
                   (setq fst '("oDleg" "LProst" "RProst")))
                 (setq _cof nil
                       pr   od
                       od   do
                       do   (GetPt #to "u" fst od code))
                 (if do
                   (progn (cond ((= do "oDleg")
                                 (while (null (setq do (GetPt "W kierunku do" "u" nil od nil))))
                                 (setq do (getRP od do)))
                                ((or (= do "LProst") (= do "RProst"))
                                 (setq do (polar od
                                                 (apply (if (= do "LProst")
                                                          '+
                                                          '-)
                                                        (list (angle pr od) #pi2))
                                                 (msg_getreal #Odleg (distance od pr) #prec))))
                          )
                          (if (null _cof)
                            (progn (czolow od do)
                                   (setq ang (+ (RGr (LspGeo (angle od do))) 100.0))
                                   (if hleft
                                     (setq wal    (_pods od (- hleft) ang)
                                           wbl    (_pods do (- hleft) ang)
                                           eNameL (_draw wal wbl eNameL)))
                                   (if hright
                                     (setq war    (_pods od hright ang)
                                           wbr    (_pods do hright ang)
                                           eNameR (_draw war wbr eNameR)))
                                   (if (and _fn (setq ssd (apply _fn (list wal wbl war wbr))))
                                     (setq ssa (ssunion ssa ssd))))))
                   (setq ex nil)))))))
    (or eNameL eNameR))
  (setq #plin nil)
  (if code
    (progn (setq Cechy (xjCechyByKod code))
           (xjWczytajCechy Cechy)
           (setq cLayer (arxGetLayer code))
           (CodeMessage code)))
  (setq ssa    (ssadd)
        ssUndo (ssadd)
        done   nil
        eNameL nil
        eNameR nil)
  (cond ((= #lst_mSci "S")
         (if (_drKrawedz "Krawd pierwsza (lub obiekt zamkniety)" 0 nil)
           (progn (setq done   eNameL
                        eNameL nil)
                  (if (not (checkClosedPolyline done))
                    (progn
                  (if (_drKrawedz "Krawd druga" 0 nil)
                    (setq eNameR eNameL
                          eNameL done)
                    (setq done nil)))))))
        (T (setq done (_drKrawedz nil hleft hright))))
  (if done
    (progn
      (cond ((and eNameL eNameR)
                  (if isClose
                    (progn (setq plin (_createPolyline (car cLayer) 1 (JoinTwoPline eNameL eNameR)))
                           (if _fnEx
                             (setq ssa (apply _fnEx (list plin nil))))
                           (entdel eNameL)
                           (entdel eNameR)
                           (setq eNameL nil
                                 eNAmeR nil)             
                      )
                    (progn (setq plin eNameL)
                           (vlax->PutProperty eNameR Cechy)
                           (if _fnEx
                             (setq ssa (apply _fnEx (list eNameL eNameR)))))))
                 (eNameL (setq plin eNameL))
                 (eNameR (setq plin eNameR))
                 ((and done (checkClosedPolyline done))
                  (setq plin done
                        eNameR nil)
                  (if _fnEx
                     (setq ssa (apply _fnEx (list plin nil))))
                  )
                 (T (setq plin nil)))
           (if plin
             (progn
               (setq oExd (read_exdata plin))
               (vlax->PutProperty plin Cechy)))
           (if (or #atrybuty (setq atrybuty (xj_GetAtrybuty 'code 'latr nil plin)))
             (progn (if #atrybuty
                      (setq atrybuty #atrybuty))
                    (if (and ssa (> (sslength ssa) 0))
                      (progn
                        (append_link plin (ssname ssa 0) #cLINK T)
                        (if eNameR
                           (progn (append_link eNameR plin "->" nil)
                               (append_link plin eNameR "<-" nil) (ssadd eNameR ssa)))))
                    (if fnText
                      (progn (mapcar fnText (list plin) (list code) (list atrybuty))
                             (if eNameR
                               (progn (append_link eNameR plin "->" nil)
                                      (append_link plin eNameR "<-" nil)
                                      (if ssa
                                        (ssadd eNameR ssa))))
                        (if oExd
                          (AppendExdata plin oExd))                        
                        ))

               
                    (if (and ssa (> (sslength ssa) 0))
                      (progn
                        (append_link (ssname ssa 0) plin #cLINK T)
                             (_makeGroup
                               (append (if eNameR
                                         (list plin eNameR)
                                         (list plin))
                                       (ssadd->list ssa))
                               code)))
                    (setq #plin plin))
             (progn (if plin
                      (entdel plin))
                    (if eNameR
                      (entdel eNameR))
                    (if (> (sslength ssUndo) 0)
                      (foreach %% (ssadd->list ssUndo) (entdel %%)))
                    (WymazElementy ssa)
               )))))


(defun MakeLay (layer / &)
  (if (null (listp layer))
    (setq layer (list layer)))
  (foreach & layer
    (if (null (tblsearch "LAYER" &))
      (arxMakeLayer &)))
  (if (tblsearch "LAYER" (car layer))
    (setLay (car layer))))


